/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 88 "src/parse.yy"


#include "decl.h"
#include "expr.h"
#include "func.h"
#include "ispc.h"
#include "module.h"
#include "stmt.h"
#include "sym.h"
#include "type.h"
#include "util.h"

#include <stdio.h>
#include <llvm/IR/Constants.h>

using namespace ispc;

#define UNIMPLEMENTED \
        Error(yylloc, "Unimplemented parser functionality %s:%d", \
        __FILE__, __LINE__);

union YYSTYPE;
extern int yylex();

extern char *yytext;

void yyerror(const char *s);

static int lYYTNameErr(char *yyres, const char *yystr);

static void lSuggestBuiltinAlternates();
static void lSuggestParamListAlternates();

static void lAddDeclaration(DeclSpecs *ds, Declarator *decl);
static void lAddTemplateDeclaration(TemplateParms *templateParmList, DeclSpecs *ds, Declarator *decl);
static void lAddFunctionParams(Declarator *decl);
static void lAddMaskToSymbolTable(SourcePos pos);
static void lAddThreadIndexCountToSymbolTable(SourcePos pos);
static std::string lGetAlternates(std::vector<std::string> &alternates);
static const char *lGetStorageClassString(StorageClass sc);
static bool lGetConstantInt(Expr *expr, int *value, SourcePos pos, const char *usage);
static EnumType *lCreateEnumType(const char *name, std::vector<Symbol *> *enums,
                                 SourcePos pos);
static void lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                                       const EnumType *enumType);

static const char *lBuiltinTokens[] = {
    "assert", "bool", "break", "case", "cdo",
    "cfor", "cif", "cwhile", "const", "continue", "default",
    "do", "delete", "double", "else", "enum", "export", "extern", "false",
    "float16", "float", "for", "foreach", "foreach_active", "foreach_tiled",
    "foreach_unique", "goto", "if", "in", "inline",
    "int", "int8", "int16", "int32", "int64", "invoke_sycl", "launch", "new", "NULL",
    "print", "return", "signed", "sizeof", "static", "struct", "switch",
    "sync", "task", "true", "typedef", "uniform", "unmasked", "unsigned",
    "varying", "void", "while", NULL
};

static const char *lParamListTokens[] = {
    "bool", "const", "double", "enum", "false", "float16", "float", "int",
    "int8", "int16", "int32", "int64", "signed", "struct", "true",
    "uniform", "unsigned", "varying", "void", NULL
};

struct ForeachDimension {
    ForeachDimension(Symbol *s = NULL, Expr *b = NULL, Expr *e = NULL) {
        sym = s;
        beginExpr = b;
        endExpr = e;
    }
    Symbol *sym;
    Expr *beginExpr, *endExpr;
};


#line 147 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parse.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOKEN_INT8_CONSTANT = 3,        /* TOKEN_INT8_CONSTANT  */
  YYSYMBOL_TOKEN_UINT8_CONSTANT = 4,       /* TOKEN_UINT8_CONSTANT  */
  YYSYMBOL_TOKEN_INT16_CONSTANT = 5,       /* TOKEN_INT16_CONSTANT  */
  YYSYMBOL_TOKEN_UINT16_CONSTANT = 6,      /* TOKEN_UINT16_CONSTANT  */
  YYSYMBOL_TOKEN_INT32_CONSTANT = 7,       /* TOKEN_INT32_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32_CONSTANT = 8,      /* TOKEN_UINT32_CONSTANT  */
  YYSYMBOL_TOKEN_INT64_CONSTANT = 9,       /* TOKEN_INT64_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64_CONSTANT = 10,     /* TOKEN_UINT64_CONSTANT  */
  YYSYMBOL_TOKEN_INT32DOTDOTDOT_CONSTANT = 11, /* TOKEN_INT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32DOTDOTDOT_CONSTANT = 12, /* TOKEN_UINT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_INT64DOTDOTDOT_CONSTANT = 13, /* TOKEN_INT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64DOTDOTDOT_CONSTANT = 14, /* TOKEN_UINT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_FLOAT16_CONSTANT = 15,    /* TOKEN_FLOAT16_CONSTANT  */
  YYSYMBOL_TOKEN_FLOAT_CONSTANT = 16,      /* TOKEN_FLOAT_CONSTANT  */
  YYSYMBOL_TOKEN_DOUBLE_CONSTANT = 17,     /* TOKEN_DOUBLE_CONSTANT  */
  YYSYMBOL_TOKEN_STRING_C_LITERAL = 18,    /* TOKEN_STRING_C_LITERAL  */
  YYSYMBOL_TOKEN_STRING_SYCL_LITERAL = 19, /* TOKEN_STRING_SYCL_LITERAL  */
  YYSYMBOL_TOKEN_IDENTIFIER = 20,          /* TOKEN_IDENTIFIER  */
  YYSYMBOL_TOKEN_STRING_LITERAL = 21,      /* TOKEN_STRING_LITERAL  */
  YYSYMBOL_TOKEN_TYPE_NAME = 22,           /* TOKEN_TYPE_NAME  */
  YYSYMBOL_TOKEN_PRAGMA = 23,              /* TOKEN_PRAGMA  */
  YYSYMBOL_TOKEN_NULL = 24,                /* TOKEN_NULL  */
  YYSYMBOL_TOKEN_TEMPLATE = 25,            /* TOKEN_TEMPLATE  */
  YYSYMBOL_TOKEN_TEMPLATE_NAME = 26,       /* TOKEN_TEMPLATE_NAME  */
  YYSYMBOL_TOKEN_TYPENAME = 27,            /* TOKEN_TYPENAME  */
  YYSYMBOL_TOKEN_PTR_OP = 28,              /* TOKEN_PTR_OP  */
  YYSYMBOL_TOKEN_INC_OP = 29,              /* TOKEN_INC_OP  */
  YYSYMBOL_TOKEN_DEC_OP = 30,              /* TOKEN_DEC_OP  */
  YYSYMBOL_TOKEN_LEFT_OP = 31,             /* TOKEN_LEFT_OP  */
  YYSYMBOL_TOKEN_RIGHT_OP = 32,            /* TOKEN_RIGHT_OP  */
  YYSYMBOL_TOKEN_LE_OP = 33,               /* TOKEN_LE_OP  */
  YYSYMBOL_TOKEN_GE_OP = 34,               /* TOKEN_GE_OP  */
  YYSYMBOL_TOKEN_EQ_OP = 35,               /* TOKEN_EQ_OP  */
  YYSYMBOL_TOKEN_NE_OP = 36,               /* TOKEN_NE_OP  */
  YYSYMBOL_TOKEN_AND_OP = 37,              /* TOKEN_AND_OP  */
  YYSYMBOL_TOKEN_OR_OP = 38,               /* TOKEN_OR_OP  */
  YYSYMBOL_TOKEN_MUL_ASSIGN = 39,          /* TOKEN_MUL_ASSIGN  */
  YYSYMBOL_TOKEN_DIV_ASSIGN = 40,          /* TOKEN_DIV_ASSIGN  */
  YYSYMBOL_TOKEN_MOD_ASSIGN = 41,          /* TOKEN_MOD_ASSIGN  */
  YYSYMBOL_TOKEN_ADD_ASSIGN = 42,          /* TOKEN_ADD_ASSIGN  */
  YYSYMBOL_TOKEN_SUB_ASSIGN = 43,          /* TOKEN_SUB_ASSIGN  */
  YYSYMBOL_TOKEN_LEFT_ASSIGN = 44,         /* TOKEN_LEFT_ASSIGN  */
  YYSYMBOL_TOKEN_RIGHT_ASSIGN = 45,        /* TOKEN_RIGHT_ASSIGN  */
  YYSYMBOL_TOKEN_AND_ASSIGN = 46,          /* TOKEN_AND_ASSIGN  */
  YYSYMBOL_TOKEN_OR_ASSIGN = 47,           /* TOKEN_OR_ASSIGN  */
  YYSYMBOL_TOKEN_XOR_ASSIGN = 48,          /* TOKEN_XOR_ASSIGN  */
  YYSYMBOL_TOKEN_SIZEOF = 49,              /* TOKEN_SIZEOF  */
  YYSYMBOL_TOKEN_NEW = 50,                 /* TOKEN_NEW  */
  YYSYMBOL_TOKEN_DELETE = 51,              /* TOKEN_DELETE  */
  YYSYMBOL_TOKEN_IN = 52,                  /* TOKEN_IN  */
  YYSYMBOL_TOKEN_INTRINSIC_CALL = 53,      /* TOKEN_INTRINSIC_CALL  */
  YYSYMBOL_TOKEN_ALLOCA = 54,              /* TOKEN_ALLOCA  */
  YYSYMBOL_TOKEN_EXTERN = 55,              /* TOKEN_EXTERN  */
  YYSYMBOL_TOKEN_EXPORT = 56,              /* TOKEN_EXPORT  */
  YYSYMBOL_TOKEN_STATIC = 57,              /* TOKEN_STATIC  */
  YYSYMBOL_TOKEN_INLINE = 58,              /* TOKEN_INLINE  */
  YYSYMBOL_TOKEN_NOINLINE = 59,            /* TOKEN_NOINLINE  */
  YYSYMBOL_TOKEN_VECTORCALL = 60,          /* TOKEN_VECTORCALL  */
  YYSYMBOL_TOKEN_REGCALL = 61,             /* TOKEN_REGCALL  */
  YYSYMBOL_TOKEN_TASK = 62,                /* TOKEN_TASK  */
  YYSYMBOL_TOKEN_DECLSPEC = 63,            /* TOKEN_DECLSPEC  */
  YYSYMBOL_TOKEN_UNIFORM = 64,             /* TOKEN_UNIFORM  */
  YYSYMBOL_TOKEN_VARYING = 65,             /* TOKEN_VARYING  */
  YYSYMBOL_TOKEN_TYPEDEF = 66,             /* TOKEN_TYPEDEF  */
  YYSYMBOL_TOKEN_SOA = 67,                 /* TOKEN_SOA  */
  YYSYMBOL_TOKEN_UNMASKED = 68,            /* TOKEN_UNMASKED  */
  YYSYMBOL_TOKEN_INT = 69,                 /* TOKEN_INT  */
  YYSYMBOL_TOKEN_SIGNED = 70,              /* TOKEN_SIGNED  */
  YYSYMBOL_TOKEN_UNSIGNED = 71,            /* TOKEN_UNSIGNED  */
  YYSYMBOL_TOKEN_FLOAT16 = 72,             /* TOKEN_FLOAT16  */
  YYSYMBOL_TOKEN_FLOAT = 73,               /* TOKEN_FLOAT  */
  YYSYMBOL_TOKEN_DOUBLE = 74,              /* TOKEN_DOUBLE  */
  YYSYMBOL_TOKEN_INT8 = 75,                /* TOKEN_INT8  */
  YYSYMBOL_TOKEN_INT16 = 76,               /* TOKEN_INT16  */
  YYSYMBOL_TOKEN_INT64 = 77,               /* TOKEN_INT64  */
  YYSYMBOL_TOKEN_CONST = 78,               /* TOKEN_CONST  */
  YYSYMBOL_TOKEN_VOID = 79,                /* TOKEN_VOID  */
  YYSYMBOL_TOKEN_BOOL = 80,                /* TOKEN_BOOL  */
  YYSYMBOL_TOKEN_UINT8 = 81,               /* TOKEN_UINT8  */
  YYSYMBOL_TOKEN_UINT16 = 82,              /* TOKEN_UINT16  */
  YYSYMBOL_TOKEN_UINT = 83,                /* TOKEN_UINT  */
  YYSYMBOL_TOKEN_UINT64 = 84,              /* TOKEN_UINT64  */
  YYSYMBOL_TOKEN_ENUM = 85,                /* TOKEN_ENUM  */
  YYSYMBOL_TOKEN_STRUCT = 86,              /* TOKEN_STRUCT  */
  YYSYMBOL_TOKEN_TRUE = 87,                /* TOKEN_TRUE  */
  YYSYMBOL_TOKEN_FALSE = 88,               /* TOKEN_FALSE  */
  YYSYMBOL_TOKEN_CASE = 89,                /* TOKEN_CASE  */
  YYSYMBOL_TOKEN_DEFAULT = 90,             /* TOKEN_DEFAULT  */
  YYSYMBOL_TOKEN_IF = 91,                  /* TOKEN_IF  */
  YYSYMBOL_TOKEN_ELSE = 92,                /* TOKEN_ELSE  */
  YYSYMBOL_TOKEN_SWITCH = 93,              /* TOKEN_SWITCH  */
  YYSYMBOL_TOKEN_WHILE = 94,               /* TOKEN_WHILE  */
  YYSYMBOL_TOKEN_DO = 95,                  /* TOKEN_DO  */
  YYSYMBOL_TOKEN_LAUNCH = 96,              /* TOKEN_LAUNCH  */
  YYSYMBOL_TOKEN_FOREACH = 97,             /* TOKEN_FOREACH  */
  YYSYMBOL_TOKEN_FOREACH_TILED = 98,       /* TOKEN_FOREACH_TILED  */
  YYSYMBOL_TOKEN_FOREACH_UNIQUE = 99,      /* TOKEN_FOREACH_UNIQUE  */
  YYSYMBOL_TOKEN_FOREACH_ACTIVE = 100,     /* TOKEN_FOREACH_ACTIVE  */
  YYSYMBOL_TOKEN_DOTDOTDOT = 101,          /* TOKEN_DOTDOTDOT  */
  YYSYMBOL_TOKEN_FOR = 102,                /* TOKEN_FOR  */
  YYSYMBOL_TOKEN_GOTO = 103,               /* TOKEN_GOTO  */
  YYSYMBOL_TOKEN_CONTINUE = 104,           /* TOKEN_CONTINUE  */
  YYSYMBOL_TOKEN_BREAK = 105,              /* TOKEN_BREAK  */
  YYSYMBOL_TOKEN_RETURN = 106,             /* TOKEN_RETURN  */
  YYSYMBOL_TOKEN_CIF = 107,                /* TOKEN_CIF  */
  YYSYMBOL_TOKEN_CDO = 108,                /* TOKEN_CDO  */
  YYSYMBOL_TOKEN_CFOR = 109,               /* TOKEN_CFOR  */
  YYSYMBOL_TOKEN_CWHILE = 110,             /* TOKEN_CWHILE  */
  YYSYMBOL_TOKEN_SYNC = 111,               /* TOKEN_SYNC  */
  YYSYMBOL_TOKEN_PRINT = 112,              /* TOKEN_PRINT  */
  YYSYMBOL_TOKEN_ASSERT = 113,             /* TOKEN_ASSERT  */
  YYSYMBOL_TOKEN_INVOKE_SYCL = 114,        /* TOKEN_INVOKE_SYCL  */
  YYSYMBOL_115_ = 115,                     /* '('  */
  YYSYMBOL_116_ = 116,                     /* ')'  */
  YYSYMBOL_117_ = 117,                     /* '['  */
  YYSYMBOL_118_ = 118,                     /* ']'  */
  YYSYMBOL_119_ = 119,                     /* ','  */
  YYSYMBOL_120_ = 120,                     /* '<'  */
  YYSYMBOL_121_ = 121,                     /* '>'  */
  YYSYMBOL_122_ = 122,                     /* '.'  */
  YYSYMBOL_123_ = 123,                     /* '&'  */
  YYSYMBOL_124_ = 124,                     /* '*'  */
  YYSYMBOL_125_ = 125,                     /* '+'  */
  YYSYMBOL_126_ = 126,                     /* '-'  */
  YYSYMBOL_127_ = 127,                     /* '~'  */
  YYSYMBOL_128_ = 128,                     /* '!'  */
  YYSYMBOL_129_ = 129,                     /* '/'  */
  YYSYMBOL_130_ = 130,                     /* '%'  */
  YYSYMBOL_131_ = 131,                     /* '^'  */
  YYSYMBOL_132_ = 132,                     /* '|'  */
  YYSYMBOL_133_ = 133,                     /* '?'  */
  YYSYMBOL_134_ = 134,                     /* ':'  */
  YYSYMBOL_135_ = 135,                     /* '='  */
  YYSYMBOL_136_ = 136,                     /* ';'  */
  YYSYMBOL_137_ = 137,                     /* '{'  */
  YYSYMBOL_138_ = 138,                     /* '}'  */
  YYSYMBOL_YYACCEPT = 139,                 /* $accept  */
  YYSYMBOL_string_constant = 140,          /* string_constant  */
  YYSYMBOL_primary_expression = 141,       /* primary_expression  */
  YYSYMBOL_launch_expression = 142,        /* launch_expression  */
  YYSYMBOL_invoke_sycl_expression = 143,   /* invoke_sycl_expression  */
  YYSYMBOL_postfix_expression = 144,       /* postfix_expression  */
  YYSYMBOL_intrinsic_name = 145,           /* intrinsic_name  */
  YYSYMBOL_intrincall_expression = 146,    /* intrincall_expression  */
  YYSYMBOL_funcall_expression = 147,       /* funcall_expression  */
  YYSYMBOL_argument_expression_list = 148, /* argument_expression_list  */
  YYSYMBOL_unary_expression = 149,         /* unary_expression  */
  YYSYMBOL_cast_expression = 150,          /* cast_expression  */
  YYSYMBOL_multiplicative_expression = 151, /* multiplicative_expression  */
  YYSYMBOL_additive_expression = 152,      /* additive_expression  */
  YYSYMBOL_shift_expression = 153,         /* shift_expression  */
  YYSYMBOL_relational_expression = 154,    /* relational_expression  */
  YYSYMBOL_equality_expression = 155,      /* equality_expression  */
  YYSYMBOL_and_expression = 156,           /* and_expression  */
  YYSYMBOL_exclusive_or_expression = 157,  /* exclusive_or_expression  */
  YYSYMBOL_inclusive_or_expression = 158,  /* inclusive_or_expression  */
  YYSYMBOL_logical_and_expression = 159,   /* logical_and_expression  */
  YYSYMBOL_logical_or_expression = 160,    /* logical_or_expression  */
  YYSYMBOL_conditional_expression = 161,   /* conditional_expression  */
  YYSYMBOL_rate_qualified_new = 162,       /* rate_qualified_new  */
  YYSYMBOL_rate_qualified_type_specifier = 163, /* rate_qualified_type_specifier  */
  YYSYMBOL_new_expression = 164,           /* new_expression  */
  YYSYMBOL_assignment_expression = 165,    /* assignment_expression  */
  YYSYMBOL_expression = 166,               /* expression  */
  YYSYMBOL_constant_expression = 167,      /* constant_expression  */
  YYSYMBOL_declaration_statement = 168,    /* declaration_statement  */
  YYSYMBOL_declaration = 169,              /* declaration  */
  YYSYMBOL_soa_width_specifier = 170,      /* soa_width_specifier  */
  YYSYMBOL_declspec_item = 171,            /* declspec_item  */
  YYSYMBOL_declspec_list = 172,            /* declspec_list  */
  YYSYMBOL_declspec_specifier = 173,       /* declspec_specifier  */
  YYSYMBOL_declaration_specifiers = 174,   /* declaration_specifiers  */
  YYSYMBOL_init_declarator_list = 175,     /* init_declarator_list  */
  YYSYMBOL_init_declarator = 176,          /* init_declarator  */
  YYSYMBOL_storage_class_specifier = 177,  /* storage_class_specifier  */
  YYSYMBOL_type_specifier = 178,           /* type_specifier  */
  YYSYMBOL_type_specifier_list = 179,      /* type_specifier_list  */
  YYSYMBOL_atomic_var_type_specifier = 180, /* atomic_var_type_specifier  */
  YYSYMBOL_short_vec_specifier = 181,      /* short_vec_specifier  */
  YYSYMBOL_struct_or_union_name = 182,     /* struct_or_union_name  */
  YYSYMBOL_struct_or_union_and_name = 183, /* struct_or_union_and_name  */
  YYSYMBOL_struct_or_union_specifier = 184, /* struct_or_union_specifier  */
  YYSYMBOL_struct_or_union = 185,          /* struct_or_union  */
  YYSYMBOL_struct_declaration_list = 186,  /* struct_declaration_list  */
  YYSYMBOL_struct_declaration = 187,       /* struct_declaration  */
  YYSYMBOL_specifier_qualifier_list = 188, /* specifier_qualifier_list  */
  YYSYMBOL_struct_declarator_list = 189,   /* struct_declarator_list  */
  YYSYMBOL_struct_declarator = 190,        /* struct_declarator  */
  YYSYMBOL_enum_identifier = 191,          /* enum_identifier  */
  YYSYMBOL_enum_specifier = 192,           /* enum_specifier  */
  YYSYMBOL_enumerator_list = 193,          /* enumerator_list  */
  YYSYMBOL_enumerator = 194,               /* enumerator  */
  YYSYMBOL_type_qualifier = 195,           /* type_qualifier  */
  YYSYMBOL_type_qualifier_list = 196,      /* type_qualifier_list  */
  YYSYMBOL_declarator = 197,               /* declarator  */
  YYSYMBOL_int_constant = 198,             /* int_constant  */
  YYSYMBOL_direct_declarator = 199,        /* direct_declarator  */
  YYSYMBOL_pointer = 200,                  /* pointer  */
  YYSYMBOL_reference = 201,                /* reference  */
  YYSYMBOL_parameter_type_list = 202,      /* parameter_type_list  */
  YYSYMBOL_parameter_list = 203,           /* parameter_list  */
  YYSYMBOL_parameter_declaration = 204,    /* parameter_declaration  */
  YYSYMBOL_type_name = 205,                /* type_name  */
  YYSYMBOL_abstract_declarator = 206,      /* abstract_declarator  */
  YYSYMBOL_direct_abstract_declarator = 207, /* direct_abstract_declarator  */
  YYSYMBOL_initializer = 208,              /* initializer  */
  YYSYMBOL_initializer_list = 209,         /* initializer_list  */
  YYSYMBOL_pragma = 210,                   /* pragma  */
  YYSYMBOL_attributed_statement = 211,     /* attributed_statement  */
  YYSYMBOL_statement = 212,                /* statement  */
  YYSYMBOL_labeled_statement = 213,        /* labeled_statement  */
  YYSYMBOL_start_scope = 214,              /* start_scope  */
  YYSYMBOL_end_scope = 215,                /* end_scope  */
  YYSYMBOL_compound_statement = 216,       /* compound_statement  */
  YYSYMBOL_statement_list = 217,           /* statement_list  */
  YYSYMBOL_expression_statement = 218,     /* expression_statement  */
  YYSYMBOL_selection_statement = 219,      /* selection_statement  */
  YYSYMBOL_for_test = 220,                 /* for_test  */
  YYSYMBOL_for_init_statement = 221,       /* for_init_statement  */
  YYSYMBOL_for_scope = 222,                /* for_scope  */
  YYSYMBOL_cfor_scope = 223,               /* cfor_scope  */
  YYSYMBOL_foreach_scope = 224,            /* foreach_scope  */
  YYSYMBOL_foreach_tiled_scope = 225,      /* foreach_tiled_scope  */
  YYSYMBOL_foreach_identifier = 226,       /* foreach_identifier  */
  YYSYMBOL_foreach_active_scope = 227,     /* foreach_active_scope  */
  YYSYMBOL_foreach_active_identifier = 228, /* foreach_active_identifier  */
  YYSYMBOL_integer_dotdotdot = 229,        /* integer_dotdotdot  */
  YYSYMBOL_foreach_dimension_specifier = 230, /* foreach_dimension_specifier  */
  YYSYMBOL_foreach_dimension_list = 231,   /* foreach_dimension_list  */
  YYSYMBOL_foreach_unique_scope = 232,     /* foreach_unique_scope  */
  YYSYMBOL_foreach_unique_identifier = 233, /* foreach_unique_identifier  */
  YYSYMBOL_iteration_statement = 234,      /* iteration_statement  */
  YYSYMBOL_235_1 = 235,                    /* $@1  */
  YYSYMBOL_236_2 = 236,                    /* $@2  */
  YYSYMBOL_237_3 = 237,                    /* $@3  */
  YYSYMBOL_238_4 = 238,                    /* $@4  */
  YYSYMBOL_goto_identifier = 239,          /* goto_identifier  */
  YYSYMBOL_jump_statement = 240,           /* jump_statement  */
  YYSYMBOL_sync_statement = 241,           /* sync_statement  */
  YYSYMBOL_delete_statement = 242,         /* delete_statement  */
  YYSYMBOL_unmasked_statement = 243,       /* unmasked_statement  */
  YYSYMBOL_print_statement = 244,          /* print_statement  */
  YYSYMBOL_assert_statement = 245,         /* assert_statement  */
  YYSYMBOL_translation_unit = 246,         /* translation_unit  */
  YYSYMBOL_external_declaration = 247,     /* external_declaration  */
  YYSYMBOL_function_definition = 248,      /* function_definition  */
  YYSYMBOL_249_5 = 249,                    /* $@5  */
  YYSYMBOL_template_type_parameter = 250,  /* template_type_parameter  */
  YYSYMBOL_template_int_parameter = 251,   /* template_int_parameter  */
  YYSYMBOL_template_parameter = 252,       /* template_parameter  */
  YYSYMBOL_template_parameter_list = 253,  /* template_parameter_list  */
  YYSYMBOL_template_head = 254,            /* template_head  */
  YYSYMBOL_template_declaration = 255,     /* template_declaration  */
  YYSYMBOL_256_6 = 256,                    /* $@6  */
  YYSYMBOL_template_function_declaration_or_definition = 257, /* template_function_declaration_or_definition  */
  YYSYMBOL_template_argument_list = 258,   /* template_argument_list  */
  YYSYMBOL_template_identifier = 259,      /* template_identifier  */
  YYSYMBOL_simple_template_id = 260,       /* simple_template_id  */
  YYSYMBOL_template_function_instantiation = 261, /* template_function_instantiation  */
  YYSYMBOL_template_function_specialization = 262 /* template_function_specialization  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  93
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4602

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  139
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  124
/* YYNRULES -- Number of rules.  */
#define YYNRULES  388
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  736

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   369


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   128,     2,     2,     2,   130,   123,     2,
     115,   116,   124,   125,   119,   126,   122,   129,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   134,   136,
     120,   135,   121,   133,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   117,     2,   118,   131,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   137,   132,   138,   127,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   298,   298,   299,   308,   327,   331,   335,   339,   343,
     347,   351,   355,   359,   367,   372,   377,   380,   383,   388,
     389,   393,   399,   406,   412,   419,   425,   431,   437,   444,
     449,   454,   459,   466,   472,   478,   484,   493,   497,   501,
     506,   507,   509,   511,   512,   514,   516,   518,   523,   530,
     546,   547,   549,   551,   553,   570,   587,   592,   593,   607,
     608,   609,   610,   612,   614,   616,   618,   620,   622,   624,
     626,   628,   630,   637,   638,   645,   646,   648,   650,   655,
     656,   658,   663,   664,   666,   671,   672,   674,   676,   678,
     683,   684,   686,   691,   692,   697,   698,   703,   704,   709,
     710,   715,   716,   721,   722,   727,   728,   729,   733,   734,
     745,   756,   780,   781,   785,   789,   796,   797,   799,   801,
     803,   805,   807,   809,   811,   813,   815,   817,   822,   823,
     828,   832,   858,   862,   869,   874,   884,   889,   898,   905,
     909,   923,   929,   939,   945,   956,   960,   966,   984,   988,
     998,  1005,  1019,  1020,  1029,  1030,  1031,  1032,  1033,  1037,
    1038,  1043,  1044,  1048,  1059,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1086,  1093,
    1094,  1098,  1120,  1121,  1141,  1155,  1163,  1180,  1184,  1191,
    1205,  1210,  1211,  1212,  1213,  1299,  1306,  1320,  1328,  1331,
    1335,  1339,  1343,  1347,  1370,  1380,  1394,  1398,  1414,  1415,
    1416,  1417,  1418,  1419,  1420,  1421,  1422,  1423,  1424,  1425,
    1429,  1433,  1440,  1452,  1464,  1468,  1469,  1470,  1471,  1475,
    1483,  1489,  1493,  1511,  1522,  1526,  1538,  1548,  1556,  1560,
    1566,  1572,  1583,  1591,  1595,  1602,  1611,  1619,  1623,  1632,
    1639,  1656,  1657,  1669,  1673,  1674,  1684,  1688,  1701,  1703,
    1709,  1726,  1737,  1755,  1757,  1763,  1773,  1787,  1788,  1789,
    1793,  1795,  1809,  1816,  1824,  1828,  1829,  1830,  1831,  1832,
    1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1848,  1852,
    1862,  1867,  1871,  1875,  1876,  1880,  1886,  1899,  1900,  1904,
    1906,  1908,  1910,  1912,  1917,  1919,  1924,  1925,  1929,  1933,
    1937,  1941,  1945,  1952,  1956,  1963,  1967,  1971,  1975,  1982,
    1986,  1993,  1998,  2012,  2016,  2020,  2022,  2024,  2026,  2028,
    2032,  2036,  2040,  2045,  2044,  2073,  2072,  2102,  2101,  2113,
    2111,  2132,  2136,  2138,  2140,  2142,  2144,  2149,  2154,  2161,
    2168,  2172,  2179,  2186,  2187,  2188,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,  2203,  2209,  2214,  2213,  2251,  2255,  2264,
    2273,  2274,  2278,  2286,  2301,  2309,  2308,  2337,  2342,  2356,
    2362,  2371,  2375,  2385,  2400,  2416,  2429,  2435,  2439
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOKEN_INT8_CONSTANT",
  "TOKEN_UINT8_CONSTANT", "TOKEN_INT16_CONSTANT", "TOKEN_UINT16_CONSTANT",
  "TOKEN_INT32_CONSTANT", "TOKEN_UINT32_CONSTANT", "TOKEN_INT64_CONSTANT",
  "TOKEN_UINT64_CONSTANT", "TOKEN_INT32DOTDOTDOT_CONSTANT",
  "TOKEN_UINT32DOTDOTDOT_CONSTANT", "TOKEN_INT64DOTDOTDOT_CONSTANT",
  "TOKEN_UINT64DOTDOTDOT_CONSTANT", "TOKEN_FLOAT16_CONSTANT",
  "TOKEN_FLOAT_CONSTANT", "TOKEN_DOUBLE_CONSTANT",
  "TOKEN_STRING_C_LITERAL", "TOKEN_STRING_SYCL_LITERAL",
  "TOKEN_IDENTIFIER", "TOKEN_STRING_LITERAL", "TOKEN_TYPE_NAME",
  "TOKEN_PRAGMA", "TOKEN_NULL", "TOKEN_TEMPLATE", "TOKEN_TEMPLATE_NAME",
  "TOKEN_TYPENAME", "TOKEN_PTR_OP", "TOKEN_INC_OP", "TOKEN_DEC_OP",
  "TOKEN_LEFT_OP", "TOKEN_RIGHT_OP", "TOKEN_LE_OP", "TOKEN_GE_OP",
  "TOKEN_EQ_OP", "TOKEN_NE_OP", "TOKEN_AND_OP", "TOKEN_OR_OP",
  "TOKEN_MUL_ASSIGN", "TOKEN_DIV_ASSIGN", "TOKEN_MOD_ASSIGN",
  "TOKEN_ADD_ASSIGN", "TOKEN_SUB_ASSIGN", "TOKEN_LEFT_ASSIGN",
  "TOKEN_RIGHT_ASSIGN", "TOKEN_AND_ASSIGN", "TOKEN_OR_ASSIGN",
  "TOKEN_XOR_ASSIGN", "TOKEN_SIZEOF", "TOKEN_NEW", "TOKEN_DELETE",
  "TOKEN_IN", "TOKEN_INTRINSIC_CALL", "TOKEN_ALLOCA", "TOKEN_EXTERN",
  "TOKEN_EXPORT", "TOKEN_STATIC", "TOKEN_INLINE", "TOKEN_NOINLINE",
  "TOKEN_VECTORCALL", "TOKEN_REGCALL", "TOKEN_TASK", "TOKEN_DECLSPEC",
  "TOKEN_UNIFORM", "TOKEN_VARYING", "TOKEN_TYPEDEF", "TOKEN_SOA",
  "TOKEN_UNMASKED", "TOKEN_INT", "TOKEN_SIGNED", "TOKEN_UNSIGNED",
  "TOKEN_FLOAT16", "TOKEN_FLOAT", "TOKEN_DOUBLE", "TOKEN_INT8",
  "TOKEN_INT16", "TOKEN_INT64", "TOKEN_CONST", "TOKEN_VOID", "TOKEN_BOOL",
  "TOKEN_UINT8", "TOKEN_UINT16", "TOKEN_UINT", "TOKEN_UINT64",
  "TOKEN_ENUM", "TOKEN_STRUCT", "TOKEN_TRUE", "TOKEN_FALSE", "TOKEN_CASE",
  "TOKEN_DEFAULT", "TOKEN_IF", "TOKEN_ELSE", "TOKEN_SWITCH", "TOKEN_WHILE",
  "TOKEN_DO", "TOKEN_LAUNCH", "TOKEN_FOREACH", "TOKEN_FOREACH_TILED",
  "TOKEN_FOREACH_UNIQUE", "TOKEN_FOREACH_ACTIVE", "TOKEN_DOTDOTDOT",
  "TOKEN_FOR", "TOKEN_GOTO", "TOKEN_CONTINUE", "TOKEN_BREAK",
  "TOKEN_RETURN", "TOKEN_CIF", "TOKEN_CDO", "TOKEN_CFOR", "TOKEN_CWHILE",
  "TOKEN_SYNC", "TOKEN_PRINT", "TOKEN_ASSERT", "TOKEN_INVOKE_SYCL", "'('",
  "')'", "'['", "']'", "','", "'<'", "'>'", "'.'", "'&'", "'*'", "'+'",
  "'-'", "'~'", "'!'", "'/'", "'%'", "'^'", "'|'", "'?'", "':'", "'='",
  "';'", "'{'", "'}'", "$accept", "string_constant", "primary_expression",
  "launch_expression", "invoke_sycl_expression", "postfix_expression",
  "intrinsic_name", "intrincall_expression", "funcall_expression",
  "argument_expression_list", "unary_expression", "cast_expression",
  "multiplicative_expression", "additive_expression", "shift_expression",
  "relational_expression", "equality_expression", "and_expression",
  "exclusive_or_expression", "inclusive_or_expression",
  "logical_and_expression", "logical_or_expression",
  "conditional_expression", "rate_qualified_new",
  "rate_qualified_type_specifier", "new_expression",
  "assignment_expression", "expression", "constant_expression",
  "declaration_statement", "declaration", "soa_width_specifier",
  "declspec_item", "declspec_list", "declspec_specifier",
  "declaration_specifiers", "init_declarator_list", "init_declarator",
  "storage_class_specifier", "type_specifier", "type_specifier_list",
  "atomic_var_type_specifier", "short_vec_specifier",
  "struct_or_union_name", "struct_or_union_and_name",
  "struct_or_union_specifier", "struct_or_union",
  "struct_declaration_list", "struct_declaration",
  "specifier_qualifier_list", "struct_declarator_list",
  "struct_declarator", "enum_identifier", "enum_specifier",
  "enumerator_list", "enumerator", "type_qualifier", "type_qualifier_list",
  "declarator", "int_constant", "direct_declarator", "pointer",
  "reference", "parameter_type_list", "parameter_list",
  "parameter_declaration", "type_name", "abstract_declarator",
  "direct_abstract_declarator", "initializer", "initializer_list",
  "pragma", "attributed_statement", "statement", "labeled_statement",
  "start_scope", "end_scope", "compound_statement", "statement_list",
  "expression_statement", "selection_statement", "for_test",
  "for_init_statement", "for_scope", "cfor_scope", "foreach_scope",
  "foreach_tiled_scope", "foreach_identifier", "foreach_active_scope",
  "foreach_active_identifier", "integer_dotdotdot",
  "foreach_dimension_specifier", "foreach_dimension_list",
  "foreach_unique_scope", "foreach_unique_identifier",
  "iteration_statement", "$@1", "$@2", "$@3", "$@4", "goto_identifier",
  "jump_statement", "sync_statement", "delete_statement",
  "unmasked_statement", "print_statement", "assert_statement",
  "translation_unit", "external_declaration", "function_definition", "$@5",
  "template_type_parameter", "template_int_parameter",
  "template_parameter", "template_parameter_list", "template_head",
  "template_declaration", "$@6",
  "template_function_declaration_or_definition", "template_argument_list",
  "template_identifier", "simple_template_id",
  "template_function_instantiation", "template_function_specialization", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-316)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-366)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1056,   -76,  -316,  4417,   102,   -66,  -316,  -316,  -316,  -316,
    -316,  -316,    -6,  -316,  -316,  -316,   -23,  -316,  -316,  -316,
    -316,  -316,  -316,  -316,  -316,  -316,  -316,  -316,  -316,  -316,
    -316,  -316,  -316,  -316,     9,  -316,  -316,  -316,  4516,  4516,
      43,  4516,  4449,  -316,   -25,  -316,    10,  -316,  4516,   563,
    -316,  -316,  -316,    67,  -316,  -316,  -316,  -316,   205,  -316,
      35,   117,    11,    22,   761,   149,   274,  -316,   158,    57,
    -316,  -316,  -316,  -316,    75,  -316,  1027,  -316,    56,  -316,
     -99,    40,    38,    38,  -316,   274,  -316,  3991,  -316,  -316,
    4022,  -316,  -316,  -316,  -316,  4516,  -316,   167,   940,  -316,
    -316,  -316,   195,   312,  4516,  -316,  -316,  -316,   185,  -316,
     204,   229,  4516,  4516,  -316,   -73,  -316,  -316,   -49,  -316,
    -316,  -316,  -316,   231,   254,   -51,  -316,   158,   251,  -316,
    1027,  -316,    75,  -316,  1192,   266,  4180,  2278,    40,    40,
     279,  -316,  4135,   287,  -316,  4063,  -316,    75,  4135,  -316,
    4094,    75,  -316,   285,  -316,  -316,  -316,  -316,  -316,  -316,
    -316,  -316,  -316,  -316,  -316,   241,  -316,  -316,  3581,  3581,
    3707,  -316,  3351,  -316,   298,   403,   412,   339,  -316,  -316,
    3759,   359,   367,   380,   382,   940,  1819,  -316,  -316,  -316,
    -316,  -316,   504,   389,   391,  1452,   413,   940,  -316,   415,
     396,   418,   419,   421,  1638,  3581,  3581,  3759,  3759,  3759,
    3759,  -316,  -316,  -316,  -316,    85,   424,  -316,  -316,   255,
    -316,    98,   126,   239,    51,   322,   417,   410,   414,   505,
      -5,  -316,  1217,  -316,  -316,    65,  -316,  -316,    43,   940,
    -316,  -316,  -316,  -316,   664,  -316,  -316,   429,   430,   435,
     436,   437,   438,  -316,   422,  -316,  -316,  -316,  -316,  -316,
    -316,   440,   425,  -316,    75,    30,  -316,  1217,  4266,   423,
     426,   761,   431,  -316,   149,  -316,  3759,    -7,  -316,   -21,
    -316,  -316,  -316,  -316,   433,  -316,   403,   412,  1192,  -316,
    -316,  -316,    14,  -316,    53,   441,   446,  -316,   448,  -316,
    -316,  -316,   451,  -316,  -316,   274,  -316,  -316,    69,  -316,
    -316,  -316,  -316,  -316,  -316,  2022,  -316,  -316,  1638,  -316,
      70,  3351,  -316,  -316,   940,   439,   940,  3351,  3351,  3351,
     465,  3351,  3299,   225,  -316,   434,  -316,  -316,  -316,    74,
    3351,   477,  3351,  -316,   553,   553,  1969,   459,    66,    94,
     460,  -316,  -316,  -316,  -316,  -316,  -316,   558,  -316,  -316,
    1766,  2150,   559,  3351,  3351,  3351,  3351,  3351,  3351,  3351,
    3351,  3351,  3351,  3351,  3351,  3759,  3759,  3759,  3759,  3759,
    3759,  3759,  3759,  3759,  3759,  3759,  3759,  3759,  3759,  3759,
    3759,  3759,  3759,  3351,   761,   761,   270,   761,  -316,  3351,
    -316,  -316,  -316,  -316,  -316,  1318,  1318,   560,   560,   562,
     564,   940,  1894,   761,   291,  -316,  -316,   277,   131,   447,
     470,  -316,  -316,  -316,  -316,  -316,  -316,  -316,  -316,     6,
    -316,  -316,   -12,  -316,  -316,  3836,  3403,   452,    21,    21,
    -316,   374,  -316,  4516,  -316,  -316,   468,    75,  -316,   474,
    -316,   475,   802,   940,  -316,   144,   166,   168,   478,   320,
     228,  2456,  -316,  -316,   173,   479,   199,  -316,     3,    16,
     480,    64,  -316,  -316,  3922,   375,   375,  -316,  3759,  -316,
     482,  -316,   200,  -316,   499,   329,  -316,   201,  -316,  -316,
    -316,  -316,  -316,  -316,  -316,  -316,  -316,  -316,  -316,  -316,
    -316,  -316,    98,    98,   126,   126,   239,   239,   239,   239,
      51,    51,   322,   417,   410,   414,   505,   -60,  -316,  -316,
    1192,  3351,  -316,  -316,  -316,  -316,  1504,  1504,  -316,   515,
    -316,   207,   209,  -316,   535,  -316,   543,  -316,   536,  -316,
     214,  -316,  -316,  -316,  1217,  -316,   517,  -316,   518,  -316,
    1140,  -316,   537,  -316,   539,   541,  -316,   540,  1192,   374,
     374,  4352,  3529,  -316,  -316,  -316,  -316,  -316,  -316,  -316,
     940,   940,   940,  3351,  1947,  3351,  2509,  -316,   215,   940,
    3351,   940,  -316,   523,  3351,  3351,  -316,  -316,  3351,  -316,
    -316,  -316,  3351,  -316,  -316,  -316,  3759,   230,   383,  -316,
      77,  2635,  2688,  2330,  -316,   560,  -316,  -316,  3351,  -316,
    -316,  -316,  -316,  -316,  -316,  -316,  -316,  -316,  -316,  -316,
    -316,   545,  -316,   544,   571,  -316,  -316,   232,  3351,  3299,
     238,   386,   554,   240,  -316,   572,   249,  -316,  -316,   263,
     264,   265,  -316,  -316,  -316,  1192,  -316,  -316,   940,   295,
     940,   296,  -316,  -316,  -316,  -316,   565,  3351,   940,  -316,
     940,   940,   304,  -316,  -316,   940,   542,   567,   280,  2814,
    3299,  3351,  -316,   555,   940,   546,   547,   556,  -316,  -316,
     940,  -316,   940,  3351,  -316,  -316,  -316,  -316,  -316,  -316,
    -316,  2096,  2867,  -316,   324,   284,   573,  -316,  -316,  -316,
    -316,  -316,  -316,  -316,  -316,   940,  3351,   334,   568,   336,
    -316,  2993,  3299,  -316,   577,  3046,  -316,   575,  -316,   341,
     344,  3299,  -316,   358,  -316,  -316,  3172,   348,  -316,  -316,
     362,  3225,  -316,  -316,   364,  -316
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,   160,     0,   155,   213,   158,   214,   215,   216,
     217,   211,     0,   209,   210,   154,     0,   212,   171,   218,
     219,   173,   174,   175,   167,   169,   176,   208,   165,   166,
     168,   170,   172,   177,     0,   187,   364,   363,   143,   141,
       0,   139,   145,   159,   182,   161,     0,   162,   148,     0,
     353,   356,   375,     0,   357,   359,   358,   355,   155,   213,
       0,     0,   156,   157,     0,     0,     0,   198,     0,   203,
     144,   142,   229,   230,     0,   242,   238,   132,     0,   150,
     152,   224,     0,     0,   140,     0,   147,     0,   179,   180,
       0,   181,   149,     1,   354,     0,   377,   291,     0,   378,
     156,   157,     0,     0,     0,   370,   371,   372,     0,   381,
     383,     0,     0,     0,   163,     0,   135,   136,     0,   225,
     226,   227,   228,     0,   206,     0,   204,     0,     0,   220,
     239,   240,     0,   133,     0,     0,     0,     0,   222,   223,
       0,   186,   192,   159,   193,     0,   188,     0,     0,   185,
       0,     0,   293,     0,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,     4,   272,    18,     0,     0,
       0,   105,     0,    48,     0,   209,   210,   212,    16,    17,
       0,     0,     0,     0,     0,     0,     0,   310,   311,   323,
     313,   308,     0,     0,     0,     0,     0,     0,   309,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   297,    40,    43,    61,    50,     0,    60,    59,    73,
      75,    79,    82,    85,    90,    93,    95,    97,    99,   101,
     103,   112,     0,   116,   128,     0,   281,   131,     0,     0,
     295,   274,   275,   276,     0,   277,   278,     0,     0,     0,
       0,     0,     0,   279,     0,   280,   284,   285,   286,   282,
     283,     0,   367,   369,     0,     0,   374,     0,     0,     0,
       0,     0,     0,   138,     0,   134,     0,     0,   199,     0,
     231,   221,   241,   151,   152,     4,     0,     0,     0,   267,
     153,   366,     0,   236,   250,     0,   243,   244,     0,   233,
      73,   130,     0,   146,   191,     0,   183,   189,     0,   195,
     197,   194,   184,   376,   287,     0,    62,    63,     0,    70,
       0,     0,   106,   107,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   341,     0,   343,   344,   345,     0,
       0,     0,     0,   347,     0,     0,     0,     0,     0,   251,
       0,    64,    65,    66,    67,    68,    69,     0,    46,    47,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   113,     0,   108,     0,
     298,   273,   292,   296,   294,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   373,   379,     0,     0,     0,
       0,   360,   361,   164,   362,   137,   207,   201,   205,     0,
     200,   270,     0,   237,   246,     0,     0,   247,   253,   256,
     249,   254,   235,     0,   234,   232,     0,     0,   190,     0,
     348,     0,     0,     0,   290,     0,     0,     0,     0,     0,
       0,     0,   342,   346,     0,     0,     0,     2,     0,     0,
       0,     0,    20,    19,     0,   253,   256,   252,     0,    45,
       0,    51,     0,    57,     0,     0,    44,     0,   118,   119,
     120,   121,   122,   123,   124,   125,   127,   126,   117,    76,
      77,    78,    80,    81,    83,    84,    88,    89,    86,    87,
      91,    92,    94,    96,    98,   100,   102,     0,   109,   110,
       0,     0,   111,   129,   307,   306,     0,     0,   312,     0,
     321,     0,     0,   314,     0,   324,     0,   288,     0,    54,
       0,   368,   387,   388,     0,   382,     0,   385,     0,   202,
       0,   268,     0,   263,     0,     0,   259,     0,     0,   255,
     257,     0,     0,   245,   178,   196,    71,    72,   349,   289,
       0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
       0,     0,     3,     0,     0,     0,    39,    37,     0,    74,
      53,    52,     0,    42,    41,    49,     0,     0,     0,   304,
       0,     0,     0,     0,   333,     0,   335,   337,     0,    56,
      55,   380,   386,   384,   269,   271,   264,   258,   260,   248,
     265,     0,   261,     0,   299,   303,   325,     0,     0,     0,
       0,     0,     0,     0,    21,   301,     0,   326,   350,     0,
       0,     0,    58,   104,   114,     0,   115,   305,     0,     0,
       0,     0,   315,   316,   317,   318,     0,     0,     0,   322,
       0,     0,     0,   266,   262,     0,     0,     0,     0,     0,
       0,     0,    34,     0,     0,     0,     0,     0,    38,   329,
       0,   331,     0,     0,   320,   334,   336,   338,   339,   300,
     327,     0,     0,    24,     0,     0,     0,    33,   302,   328,
     351,   352,   330,   332,   319,     0,     0,     0,     0,     0,
      23,     0,     0,   340,     0,     0,    36,     0,    26,     0,
       0,     0,    28,     0,    35,    25,     0,     0,    27,    30,
       0,     0,    29,    32,     0,    31
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -316,   332,  -316,  -316,  -316,  -183,  -316,  -316,  -316,  -247,
     224,  -156,   128,   129,  -139,   130,   309,   311,   308,   310,
     313,  -316,  -125,  -316,  -251,  -316,  -134,   -54,  -174,   109,
      27,  -223,   432,  -316,  -316,     1,  -316,   576,  -316,   -59,
    -316,   -70,  -316,  -316,  -316,  -316,  -316,   613,   -18,  -123,
    -316,   257,   673,  -316,   582,  -255,   -42,  -316,   -22,   -64,
     -68,   -69,  -283,  -126,  -316,   267,   393,  -238,  -315,  -132,
     192,  -316,  -162,  -316,  -316,  -316,  -316,   -45,   392,   116,
    -316,   253,   350,  -316,  -316,  -316,  -316,  -316,  -316,  -316,
    -316,   160,   373,  -316,  -316,  -316,  -316,  -316,  -316,  -316,
     590,  -316,  -316,  -316,  -316,  -316,  -316,  -316,   735,  -316,
    -316,  -316,  -316,   520,  -316,  -316,  -316,  -316,  -316,  -316,
    -316,   732,  -316,  -316
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   468,   212,   213,   214,   215,   216,   217,   218,   482,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   396,   233,   234,   235,   302,   236,
     237,    38,   117,   118,    39,   238,    78,    79,    41,    42,
     115,    43,   144,    91,    44,    45,    46,   145,   146,   147,
     308,   309,   124,    47,   125,   126,    48,   130,   128,   123,
      81,    82,    83,   554,   296,   297,   350,   555,   441,   431,
     432,   239,   240,   241,   242,    98,   404,   243,   244,   245,
     246,   601,   526,   247,   248,   249,   250,   529,   251,   534,
     657,   530,   531,   252,   536,   253,   658,   660,   661,   705,
     254,   255,   256,   257,   258,   259,   260,    49,    50,    51,
     135,   105,   106,   107,   108,    52,    53,    95,    54,   417,
     110,   261,    55,    56
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     289,    40,   290,   333,    61,   114,   325,   131,    99,   397,
     295,   439,   301,    67,   138,   139,   416,   143,    80,   304,
     143,   140,   428,   330,   582,   311,    67,    37,   142,    67,
      88,   142,    89,   392,   129,   341,   134,   582,  -365,    70,
      71,    72,    84,    86,   397,   148,   271,    73,   148,    92,
      40,   353,   354,   355,   356,   301,   440,   102,    72,   399,
      57,   282,   102,    72,    73,   272,   476,   273,   277,    73,
     274,    64,   143,    72,   596,   143,    37,   401,   143,    73,
     143,   349,   403,   142,   382,   383,   142,   278,   281,   142,
     291,   142,   357,   358,   359,    72,   151,    66,   429,   103,
     148,    73,   426,   148,   103,   264,   148,   550,   148,    65,
     284,   477,    87,   357,   358,   359,   487,   430,   320,   583,
      62,    63,   584,   559,   560,   310,   551,   307,   393,   313,
     433,   427,   307,   434,   143,   585,   435,   294,   436,   269,
     270,   339,   420,   109,   549,   142,    68,    90,   112,   460,
     348,   301,   439,    74,   289,   136,   104,   137,    74,   113,
     559,   560,   148,   471,   454,   540,    75,    76,   435,   116,
     436,   384,   385,   398,   428,   132,    75,    76,    67,    77,
     587,   361,   473,   588,   399,   399,   362,   451,   447,   399,
      74,   476,   133,   399,   127,   349,   399,   459,    75,    76,
     360,   400,   361,    96,    97,   448,   450,   362,   398,   474,
     463,   436,   423,   647,   578,   262,   284,    75,    76,   499,
     500,   501,   375,   100,   101,   438,   483,   376,   377,   483,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   446,   414,   506,   507,   508,   509,   546,   143,   537,
     434,   378,   379,   357,   358,   359,   357,   358,   359,   142,
     570,   348,   557,   399,   348,   523,   357,   358,   359,   294,
     380,   381,   437,   455,   456,   457,   148,   119,   483,   120,
     475,   121,   571,   122,   572,   399,   464,   399,   466,   579,
     403,   569,   399,   611,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   265,   152,   266,   485,   357,   358,
     359,   301,   357,   358,   359,   581,   591,   595,   399,   592,
     592,   397,   589,   604,   267,   606,   605,   483,   605,   633,
     610,   634,   263,   592,   592,   518,   519,   639,   522,   517,
     461,   641,   361,   576,   268,   361,   644,   362,   666,   645,
     362,   399,   275,   669,   541,   361,   673,   386,   387,   592,
     362,   300,   357,   358,   359,   675,   438,   280,   399,   543,
     138,   139,   357,   358,   359,  -341,   357,   358,   359,   676,
     677,   678,   592,   399,   592,   520,   289,   521,   623,   276,
     374,   630,   316,   317,   319,   692,   544,   361,   545,   711,
     303,   361,   362,    97,   300,   475,   362,   305,   624,   625,
     626,   680,   682,   321,   399,   399,   289,   635,   615,   637,
     688,   314,   694,   399,   289,   310,   619,   542,    97,   351,
     352,   300,   300,   300,   300,   621,   294,   301,   574,   575,
     710,   631,   483,   592,   294,   709,   668,   594,   399,   715,
     483,   361,   717,   322,   483,   592,   362,   725,   642,   726,
     592,   361,   323,   731,   719,   361,   362,   598,   723,   656,
     362,   643,   600,   600,   728,   294,   324,   592,   732,   730,
     735,   592,   327,   592,   734,   398,   679,   695,   681,   561,
     474,   562,   436,   326,   667,   328,   685,   329,   686,   687,
     300,   646,   399,   689,   670,   671,   502,   503,   707,   504,
     505,   289,   698,   615,   524,   524,   510,   511,   702,   627,
     703,   525,   525,   684,   334,   336,   636,   337,   340,   720,
     342,   640,   343,   344,   345,   483,   346,   696,   727,   363,
     388,   389,   391,   713,   405,   406,   390,   649,   651,   704,
     407,   408,   409,   410,   662,   412,   411,   442,   483,   458,
     413,   421,   294,    93,   422,   443,   444,   424,   134,   445,
     462,   465,   714,   453,   467,   472,   478,   483,   479,   486,
     528,   483,   533,   547,   535,     2,   548,   558,     3,   564,
     566,   567,   483,   573,   580,   608,   586,   483,   590,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   593,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
     603,   607,   609,   612,   613,   616,   434,   617,   618,   638,
     300,   663,   664,   665,   674,   153,   683,   154,   155,   156,
     157,   158,   159,   160,   161,   672,   697,   469,   690,   162,
     163,   164,   699,   700,   165,   691,     2,   166,   167,   716,
     109,   712,   701,   168,   169,   721,   724,   512,   514,    36,
     513,   515,   300,   150,   565,   516,   425,    69,   283,   279,
     563,   449,   597,   170,   171,   172,   452,   173,   174,    58,
      59,     6,     7,     8,     9,    10,    11,    12,   175,   176,
      15,    16,   177,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,   178,   179,   180,   181,   182,   527,   183,   184,   185,
     186,   187,   188,   189,   190,   659,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     602,   532,   335,     2,    94,   415,   300,   205,   206,   207,
     208,   209,   210,   111,     0,     0,     0,     0,     0,     0,
     211,    97,   402,   153,     0,   154,   155,   156,   157,   158,
     159,   160,   161,     0,     0,     0,     0,   162,   163,   164,
     300,     0,   165,     0,     2,   166,   167,     0,   109,     0,
      18,   168,   169,    21,    22,    23,    24,    25,    26,     0,
      28,    29,    30,    31,    32,    33,    34,    35,     0,     0,
       0,   170,   171,   172,     0,   173,   174,    58,    59,     6,
       7,     8,     9,    10,    11,    12,   175,   176,    15,    16,
     177,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,   178,
     179,   180,   181,   182,     0,   183,   184,   185,   186,   187,
     188,   189,   190,     0,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,     0,     0,
       0,     0,     0,     0,     0,   205,   206,   207,   208,   209,
     210,     0,     0,     0,     0,     0,     0,     0,   211,    97,
     568,   153,     0,   154,   155,   156,   157,   158,   159,   160,
     161,     0,     0,     0,     0,   162,   163,   164,     0,     0,
     165,     0,     2,   166,   167,     0,   109,     0,     0,   168,
     169,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   170,
     171,   172,     0,   173,   174,    58,    59,     6,     7,     8,
       9,    10,    11,    12,   175,   176,    15,    16,   177,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,   178,   179,   180,
     181,   182,     0,   183,   184,   185,   186,   187,   188,   189,
     190,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,     0,     1,     0,     0,
       0,     0,     0,   205,   206,   207,   208,   209,   210,     0,
       0,     0,     0,     0,     0,     0,   211,    97,     2,     0,
       0,     3,     0,    59,     0,     7,     8,     9,    10,    11,
       0,    13,    14,     0,     0,    17,     0,    19,    20,     0,
       0,     0,     0,     0,     0,    27,     0,     0,     0,     0,
       0,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,   154,   155,   156,   157,   158,   159,   160,
     161,    76,     0,     0,     0,   162,   163,   164,     0,     0,
     285,     0,     0,     0,   167,     0,   109,     0,     0,   168,
     169,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   170,
     171,     0,    36,   173,   174,   154,   155,   156,   157,   158,
     159,   160,   161,     0,   286,   287,     0,   162,   163,   164,
       0,     0,   285,     0,     0,     0,   167,     0,   109,     0,
       0,   168,   169,     0,     0,     0,     0,   178,   179,     0,
       0,     0,     0,     0,     0,     0,   186,     0,     0,     2,
       0,   170,   171,     0,     0,   173,   174,     0,     0,     0,
       0,     0,     0,     0,   203,   204,   286,   287,     0,     0,
       0,     0,     0,   205,   206,   207,   208,   209,   210,     0,
       0,     0,     0,     0,     0,     0,     0,   288,   614,   178,
     179,   394,   395,     0,    16,     0,    18,     0,   186,    21,
      22,    23,    24,    25,    26,     0,    28,    29,    30,    31,
      32,    33,    34,    35,     0,     0,   203,   204,     0,     0,
       0,     0,     0,     0,     0,   205,   206,   207,   208,   209,
     210,   154,   155,   156,   157,   158,   159,   160,   161,   288,
       0,     0,     0,   162,   163,   164,     0,     0,   285,     0,
       2,     0,   167,     0,   109,     0,     0,   168,   169,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   170,   171,     0,
       0,   173,   174,    58,    59,     6,     7,     8,     9,    10,
      11,    12,   175,   176,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,   178,   179,     0,     0,     0,
       0,     0,     0,     0,   186,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   203,   204,     0,     0,     0,     0,     0,     0,
       0,   205,   206,   207,   208,   209,   210,     0,     0,     0,
       0,     0,     0,     0,   211,   154,   155,   156,   157,   158,
     159,   160,   161,     0,     0,     0,     0,   162,   163,   164,
       0,     0,   285,     0,     0,     0,   167,     0,   109,     0,
       0,   168,   169,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   170,   171,     0,     0,   173,   174,   154,   155,   156,
     157,   158,   159,   160,   161,     0,   286,   287,     0,   162,
     163,   164,     0,     0,   285,     0,     0,     0,   167,     0,
     109,     0,     0,   168,   169,     0,     0,     0,     0,   178,
     179,     0,     0,     0,     0,     0,     0,     0,   186,     0,
       0,     0,     0,   170,   171,     0,     0,   173,   174,     0,
       0,     0,     0,     0,     0,     0,   203,   204,   286,   287,
       0,     0,     0,     0,     0,   205,   206,   207,   208,   209,
     210,     0,     0,     0,     0,     0,     0,     0,   338,     0,
       0,   178,   179,     0,     0,     0,     0,     0,     0,     0,
     186,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   203,   204,
       0,     0,     0,     0,     0,     0,     0,   205,   206,   207,
     208,   209,   210,     0,     0,     0,     0,     0,     0,   347,
     599,   154,   155,   156,   157,   158,   159,   160,   161,     0,
       0,     0,     0,   162,   163,   164,     0,     0,   285,     0,
       2,     0,   167,     0,   109,     0,     0,   168,   169,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   170,   171,     0,
       0,   173,   174,     0,    59,     0,     7,     8,     9,    10,
      11,     0,   175,   176,     0,     0,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,   178,   179,     0,     0,     0,
       0,     0,     0,     0,   186,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   203,   204,     0,     0,     0,     0,     0,     0,
       0,   205,   206,   207,   208,   209,   210,   480,     0,   154,
     155,   156,   157,   158,   159,   160,   161,     0,     0,     0,
       0,   162,   163,   164,     0,     0,   285,     0,     0,     0,
     167,     0,   109,     0,     0,   168,   169,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   170,   171,     0,     0,   173,
     174,     0,   154,   155,   156,   157,   158,   159,   160,   161,
     286,   287,     0,     0,   162,   163,   164,     0,     0,   285,
       0,     0,     0,   167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   178,   179,     0,     0,     0,     0,     0,
       0,     0,   186,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     203,   204,   481,     0,     0,     0,     0,     0,     0,   205,
     206,   207,   208,   209,   210,   538,     0,   154,   155,   156,
     157,   158,   159,   160,   161,     0,   178,   179,     0,   162,
     163,   164,     0,     0,   285,   186,     0,     0,   167,     0,
     109,     0,     0,   168,   169,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   315,     0,   331,     0,     0,   332,
       0,     0,     0,   170,   171,     0,     0,   173,   174,     0,
     154,   155,   156,   157,   158,   159,   160,   161,   286,   287,
       0,     0,   162,   163,   164,     0,     0,   285,     0,     0,
     470,   167,   154,   155,   156,   157,   158,   159,   160,   161,
       0,   178,   179,     0,   162,   163,   164,     0,     0,   285,
     186,     0,     0,   167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   203,   204,
     539,     0,     0,     0,     0,     0,     0,   205,   206,   207,
     208,   209,   210,   347,     0,   154,   155,   156,   157,   158,
     159,   160,   161,     0,   178,   179,     0,   162,   163,   164,
       0,     0,   285,   186,     0,     0,   167,     0,   109,     0,
       0,   168,   169,     0,     0,     0,   178,   179,     0,     0,
       0,     0,   315,     0,   628,   186,     0,   629,     0,     0,
       0,   170,   171,     0,     0,   173,   174,     0,     0,     0,
       0,     0,     0,     0,   315,     0,   286,   287,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   154,
     155,   156,   157,   158,   159,   160,   161,     0,     0,   178,
     179,   162,   163,   164,     0,     0,   285,     0,   186,     0,
     167,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   203,   204,     0,     0,
       0,     0,     0,     0,     0,   205,   206,   207,   208,   209,
     210,   484,     0,   154,   155,   156,   157,   158,   159,   160,
     161,     0,     0,     0,     0,   162,   163,   164,     0,     0,
     285,     0,     0,     0,   167,     0,   109,     0,     0,   168,
     169,     0,     0,   178,   179,     0,     0,     0,     0,     0,
       0,     0,   186,     0,     0,     0,     0,     0,     0,   170,
     171,     0,     0,   173,   174,     0,     0,     0,     0,     0,
       0,   315,     0,   706,   286,   287,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   178,   179,     0,
       0,     0,     0,     0,     0,     0,   186,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   203,   204,     0,     0,     0,     0,
       0,     0,     0,   205,   206,   207,   208,   209,   210,   298,
       0,   154,   155,   156,   157,   158,   159,   160,   161,     0,
       0,     0,     0,   162,   163,   164,     0,     0,   285,     0,
       0,     0,   167,     0,   109,     0,     0,   168,   169,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   170,     0,     0,
       0,   173,   174,   154,   155,   156,   157,   158,   159,   160,
     161,   652,   653,   654,   655,   162,   163,   164,     0,     0,
     285,     0,     0,     0,   167,     0,   109,     0,     0,   168,
     169,     0,     0,     0,     0,   178,   179,     0,     0,     0,
       0,     0,     0,     0,   186,     0,     0,     0,     0,   170,
     171,     0,     0,   173,   174,     0,     0,     0,     0,     0,
       0,     0,   203,   204,   286,   287,   299,     0,     0,     0,
       0,   205,   206,   207,   208,   209,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   178,   179,     0,
       0,     0,     0,     0,     0,     0,   186,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   203,   204,     0,     0,     0,     0,
       0,     0,     0,   205,   206,   207,   208,   209,   210,   154,
     155,   156,   157,   158,   159,   160,   161,     0,     0,     0,
       0,   162,   163,   164,     0,     0,   285,     0,     0,     0,
     167,     0,   109,     0,     0,   168,   169,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   170,   171,     0,     0,   173,
     174,     0,   154,   155,   156,   157,   158,   159,   160,   161,
     286,   287,     0,     0,   162,   163,   164,     0,     0,   285,
       0,     0,     0,   167,     0,   109,     0,     0,   168,   169,
       0,     0,     0,   178,   179,     0,     0,     0,     0,     0,
       0,     0,   186,     0,     0,     0,     0,     0,   170,   171,
       0,     0,   173,   174,     0,     0,     0,     0,     0,     0,
     203,   204,   577,   286,   287,     0,     0,     0,     0,   205,
     206,   207,   208,   209,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   178,   179,     0,     0,
       0,     0,     0,     0,     0,   186,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   203,   204,   632,     0,     0,     0,     0,
       0,     0,   205,   206,   207,   208,   209,   210,   154,   155,
     156,   157,   158,   159,   160,   161,     0,     0,     0,     0,
     162,   163,   164,     0,     0,   285,     0,     0,     0,   167,
       0,   109,     0,     0,   168,   169,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   170,   171,     0,     0,   173,   174,
       0,   154,   155,   156,   157,   158,   159,   160,   161,   286,
     287,     0,     0,   162,   163,   164,     0,     0,   285,     0,
       0,     0,   167,     0,   109,     0,     0,   168,   169,     0,
       0,     0,   178,   179,     0,     0,     0,     0,     0,     0,
       0,   186,     0,     0,     0,     0,     0,   170,   171,     0,
       0,   173,   174,     0,     0,     0,     0,     0,     0,   203,
     204,   648,   286,   287,     0,     0,     0,     0,   205,   206,
     207,   208,   209,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   178,   179,     0,     0,     0,
       0,     0,     0,     0,   186,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   203,   204,   650,     0,     0,     0,     0,     0,
       0,   205,   206,   207,   208,   209,   210,   154,   155,   156,
     157,   158,   159,   160,   161,     0,     0,     0,     0,   162,
     163,   164,     0,     0,   285,     0,     0,     0,   167,     0,
     109,     0,     0,   168,   169,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   170,   171,     0,     0,   173,   174,     0,
     154,   155,   156,   157,   158,   159,   160,   161,   286,   287,
       0,     0,   162,   163,   164,     0,     0,   285,     0,     0,
       0,   167,     0,   109,     0,     0,   168,   169,     0,     0,
       0,   178,   179,     0,     0,     0,     0,     0,     0,     0,
     186,     0,     0,     0,     0,     0,   170,   171,     0,     0,
     173,   174,     0,     0,     0,     0,     0,     0,   203,   204,
     693,   286,   287,     0,     0,     0,     0,   205,   206,   207,
     208,   209,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   178,   179,     0,     0,     0,     0,
       0,     0,     0,   186,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   203,   204,   708,     0,     0,     0,     0,     0,     0,
     205,   206,   207,   208,   209,   210,   154,   155,   156,   157,
     158,   159,   160,   161,     0,     0,     0,     0,   162,   163,
     164,     0,     0,   285,     0,     0,     0,   167,     0,   109,
       0,     0,   168,   169,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   170,   171,     0,     0,   173,   174,     0,   154,
     155,   156,   157,   158,   159,   160,   161,   286,   287,     0,
       0,   162,   163,   164,     0,     0,   285,     0,     0,     0,
     167,     0,   109,     0,     0,   168,   169,     0,     0,     0,
     178,   179,     0,     0,     0,     0,     0,     0,     0,   186,
       0,     0,     0,     0,     0,   170,   171,     0,     0,   173,
     174,     0,     0,     0,     0,     0,     0,   203,   204,   718,
     286,   287,     0,     0,     0,     0,   205,   206,   207,   208,
     209,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   178,   179,     0,     0,     0,     0,     0,
       0,     0,   186,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     203,   204,   722,     0,     0,     0,     0,     0,     0,   205,
     206,   207,   208,   209,   210,   154,   155,   156,   157,   158,
     159,   160,   161,     0,     0,     0,     0,   162,   163,   164,
       0,     0,   285,     0,     0,     0,   167,     0,   109,     0,
       0,   168,   169,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   170,   171,     0,     0,   173,   174,     0,   154,   155,
     156,   157,   158,   159,   160,   161,   286,   287,     0,     0,
     162,   163,   164,     0,     0,   285,     0,     0,     0,   167,
       0,   109,     0,     0,   168,   169,     0,     0,     0,   178,
     179,     0,     0,     0,     0,     0,     0,     0,   186,     0,
       0,     0,     0,     0,   170,   171,     0,     0,   173,   174,
       0,     0,     0,     0,     0,     0,   203,   204,   729,   286,
     287,     0,     0,     0,     0,   205,   206,   207,   208,   209,
     210,     0,   154,   155,   156,   157,   158,   159,   160,   161,
       0,     0,   178,   179,   162,   163,   164,     0,     0,   285,
       0,   186,     0,   167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   203,
     204,   733,     0,     0,     0,     0,     0,     0,   205,   206,
     207,   208,   209,   210,   154,   155,   156,   157,   158,   159,
     160,   161,     0,     0,     0,     0,   162,   163,   164,     0,
       0,   285,     0,     0,     0,   167,     0,   109,     0,     0,
     168,   169,     0,     0,     0,     0,   178,   179,     0,     0,
       0,     0,     0,     0,     0,   186,     0,     0,     0,     0,
     170,   171,     0,     0,   173,   174,   154,   155,   156,   157,
     158,   159,   160,   161,   315,   286,   287,     0,   162,   163,
     164,     0,     0,   285,     0,     0,     0,   167,     0,   109,
       0,     0,   168,   169,     0,     0,     0,     0,   178,   179,
       0,     0,     0,     0,     0,     0,     0,   186,     0,     0,
       0,     0,   170,     0,     0,     0,   173,   174,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,     0,     0,
       0,     0,     0,     0,   205,   206,   207,   208,   209,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     178,   179,     0,     0,     0,     0,     0,     0,     0,   186,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
       0,   556,     0,     0,     0,     0,   205,   206,   207,   208,
     209,   210,   154,   155,   156,   157,   158,   159,   160,   161,
       0,     0,     0,     0,   162,   163,   164,     0,     0,   285,
       0,     0,     0,   167,     0,   109,     0,     0,   168,   169,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   170,     0,
       0,     0,   173,   174,   154,   155,   156,   157,   158,   159,
     160,   161,     0,     0,     0,     0,   162,   163,   164,     0,
       0,   285,     0,     0,     0,   167,     0,   109,     0,     0,
     168,   169,     0,     0,     0,     0,   178,   179,     0,     0,
       0,     0,     0,     0,     0,   186,     0,     0,     0,     0,
     170,     0,     0,     0,   173,   174,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,     0,   622,     0,     0,
       0,     0,   205,   206,   207,   208,   209,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   178,   179,
       0,     0,     0,     0,     0,     0,     0,   186,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   203,   315,     0,     0,     0,
       0,     0,     0,     0,   205,   206,   207,   208,   209,   210,
     154,   155,   156,   157,   158,   159,   160,   161,     0,     0,
       0,     0,   162,   163,   164,     0,     0,   285,     0,     0,
       0,   167,     0,   109,     0,     0,   168,   169,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   170,     0,     0,     0,
     173,   174,   154,   155,   156,   157,   158,   159,   160,   161,
       0,     0,     0,     0,   162,   163,   164,     0,     0,   285,
       0,     0,     0,   167,     0,   109,     0,     0,   168,   169,
       0,     0,     0,     0,   178,   179,     0,     0,     0,     0,
       0,     0,     0,   186,     0,     0,     0,     0,   170,     0,
       0,     0,   173,   174,     0,     0,     0,     0,     0,     0,
       0,   203,   318,     0,     0,     0,     0,     0,     0,     0,
     205,   206,   207,   208,   209,   210,     0,   552,     0,     0,
       0,     0,     0,     0,     0,     0,   178,   179,     0,     0,
       0,     0,     0,     0,     0,   186,    72,     0,     2,     0,
       0,     0,    73,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,     0,     0,     0,     0,
       0,     0,   205,   206,   207,   208,   209,   210,     0,     0,
       0,    58,    59,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,   552,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,     0,     0,     0,     0,     0,
       0,   435,   553,   436,     0,     0,     0,     0,     0,    75,
      76,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    58,    59,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,     0,
       0,     0,     0,     2,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   474,   553,   436,
       0,     0,     0,     0,     2,    75,    76,    59,     0,     7,
       8,     9,    10,    11,     0,    13,    14,     0,     0,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    59,     0,
       7,     8,     9,    10,    11,     2,    13,    14,     0,     0,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,     0,
       0,     0,     0,     0,     0,     0,     2,     0,     0,    59,
       0,     7,     8,     9,    10,    11,     0,    13,    14,   141,
       0,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      59,     0,     7,     8,     9,    10,    11,     2,    13,    14,
     149,     0,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,   292,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    59,     0,     7,     8,     9,    10,    11,     0,    13,
      14,   306,     2,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   312,     0,     0,    58,    59,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,   418,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     2,     0,
       0,     0,     0,     0,     0,     0,   293,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    58,    59,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,   552,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,     0,     0,     0,     0,     0,
       0,     0,   419,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    58,    59,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,     2,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   620,     0,
       0,     2,    58,    59,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    58,    59,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,     0,    60,     2,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    85,
       0,    58,    59,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35
};

static const yytype_int16 yycheck[] =
{
     134,     0,   134,   186,     3,    64,   180,    76,    53,   232,
     136,   294,   137,    20,    82,    83,   267,    87,    40,   142,
      90,    85,   277,   185,    21,   148,    20,     0,    87,    20,
      20,    90,    22,    38,    76,   197,   135,    21,   137,    38,
      39,    20,    41,    42,   267,    87,   119,    26,    90,    48,
      49,   207,   208,   209,   210,   180,   294,    27,    20,   119,
     136,   130,    27,    20,    26,   138,   349,   116,   119,    26,
     119,   137,   142,    20,   134,   145,    49,   239,   148,    26,
     150,   204,   244,   142,    33,    34,   145,   138,   130,   148,
     135,   150,    28,    29,    30,    20,    95,   120,   119,    69,
     142,    26,   276,   145,    69,   104,   148,   119,   150,   115,
     132,   349,   137,    28,    29,    30,   363,   138,   172,   116,
      18,    19,   119,   438,   439,   147,   138,   145,   133,   151,
     116,   138,   150,   119,   204,   119,   115,   136,   117,   112,
     113,   195,   268,    26,   138,   204,   137,   137,   137,   332,
     204,   276,   435,   115,   288,   115,   121,   117,   115,   137,
     475,   476,   204,   346,   326,   412,   123,   124,   115,    20,
     117,   120,   121,   232,   429,   119,   123,   124,    20,   136,
     116,   117,   116,   119,   119,   119,   122,   321,   119,   119,
     115,   474,   136,   119,   137,   318,   119,   331,   123,   124,
     115,   136,   117,   136,   137,   136,   136,   122,   267,   115,
     136,   117,   271,   136,   461,    20,   238,   123,   124,   375,
     376,   377,   124,    18,    19,   294,   360,   129,   130,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   305,   264,   382,   383,   384,   385,   116,   318,   411,
     119,   125,   126,    28,    29,    30,    28,    29,    30,   318,
     116,   315,   436,   119,   318,   399,    28,    29,    30,   268,
      31,    32,   294,   327,   328,   329,   318,     3,   412,     5,
     349,     7,   116,     9,   116,   119,   340,   119,   342,   116,
     452,   453,   119,   544,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,   119,   138,   121,   361,    28,    29,
      30,   436,    28,    29,    30,   116,   116,   116,   119,   119,
     119,   544,   478,   116,   120,   116,   119,   461,   119,   576,
     116,   116,    20,   119,   119,   394,   395,   584,   397,   393,
     115,   588,   117,   115,   115,   117,   116,   122,   116,   119,
     122,   119,   121,   115,   413,   117,   116,    35,    36,   119,
     122,   137,    28,    29,    30,   116,   435,   116,   119,   414,
     438,   439,    28,    29,    30,   134,    28,    29,    30,   116,
     116,   116,   119,   119,   119,   115,   520,   117,   562,   135,
     135,   574,   168,   169,   170,   115,   119,   117,   121,   115,
     121,   117,   122,   137,   180,   474,   122,   120,   570,   571,
     572,   116,   116,   115,   119,   119,   550,   579,   550,   581,
     116,   136,   669,   119,   558,   447,   558,   136,   137,   205,
     206,   207,   208,   209,   210,   561,   435,   562,   118,   119,
     116,   575,   576,   119,   443,   692,   629,   118,   119,   115,
     584,   117,   116,    50,   588,   119,   122,   116,   592,   115,
     119,   117,    50,   115,   711,   117,   122,   521,   715,   603,
     122,   596,   526,   527,   116,   474,   137,   119,   116,   726,
     116,   119,   115,   119,   731,   544,   648,   670,   650,   115,
     115,   117,   117,   134,   628,   115,   658,   115,   660,   661,
     276,   118,   119,   665,   118,   119,   378,   379,   691,   380,
     381,   645,   674,   645,   405,   406,   386,   387,   680,   573,
     682,   405,   406,   657,    20,   136,   580,   136,   115,   712,
     115,   585,   136,   115,   115,   669,   115,   671,   721,   115,
     123,   131,    37,   705,   115,   115,   132,   601,   602,   683,
     115,   115,   115,   115,   608,   115,   134,   116,   692,    94,
     135,   138,   561,     0,   138,   119,   118,   136,   135,   118,
     136,    94,   706,   134,    21,   116,   116,   711,    20,    20,
      20,   715,    20,   136,    20,    22,   116,   135,    25,   121,
     116,   116,   726,   115,   115,    52,   116,   731,   116,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   118,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
     135,   116,   116,   136,   136,   116,   119,   116,   118,   136,
     436,   116,   118,    92,    92,     1,   101,     3,     4,     5,
       6,     7,     8,     9,    10,   121,   121,   345,   136,    15,
      16,    17,   136,   136,    20,   118,    22,    23,    24,   121,
      26,   118,   136,    29,    30,   118,   121,   388,   390,   136,
     389,   391,   478,    90,   447,   392,   274,    34,   132,   127,
     443,   318,   520,    49,    50,    51,   324,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,   406,    93,    94,    95,
      96,    97,    98,    99,   100,   605,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     527,   408,   192,    22,    49,   265,   562,   123,   124,   125,
     126,   127,   128,    61,    -1,    -1,    -1,    -1,    -1,    -1,
     136,   137,   138,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,
     596,    -1,    20,    -1,    22,    23,    24,    -1,    26,    -1,
      69,    29,    30,    72,    73,    74,    75,    76,    77,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    -1,
      -1,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   123,   124,   125,   126,   127,
     128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   136,   137,
     138,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,
      20,    -1,    22,    23,    24,    -1,    26,    -1,    -1,    29,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    99,
     100,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,    -1,     1,    -1,    -1,
      -1,    -1,    -1,   123,   124,   125,   126,   127,   128,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   136,   137,    22,    -1,
      -1,    25,    -1,    56,    -1,    58,    59,    60,    61,    62,
      -1,    64,    65,    -1,    -1,    68,    -1,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,     3,     4,     5,     6,     7,     8,     9,
      10,   124,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,
      20,    -1,    -1,    -1,    24,    -1,    26,    -1,    -1,    29,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      50,    -1,   136,    53,    54,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    64,    65,    -1,    15,    16,    17,
      -1,    -1,    20,    -1,    -1,    -1,    24,    -1,    26,    -1,
      -1,    29,    30,    -1,    -1,    -1,    -1,    87,    88,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    22,
      -1,    49,    50,    -1,    -1,    53,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,   115,    64,    65,    -1,    -1,
      -1,    -1,    -1,   123,   124,   125,   126,   127,   128,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,   138,    87,
      88,    64,    65,    -1,    67,    -1,    69,    -1,    96,    72,
      73,    74,    75,    76,    77,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    -1,   114,   115,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   123,   124,   125,   126,   127,
     128,     3,     4,     5,     6,     7,     8,     9,    10,   137,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,
      22,    -1,    24,    -1,    26,    -1,    -1,    29,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,
      -1,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   123,   124,   125,   126,   127,   128,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   136,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,
      -1,    -1,    20,    -1,    -1,    -1,    24,    -1,    26,    -1,
      -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    50,    -1,    -1,    53,    54,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    64,    65,    -1,    15,
      16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,    -1,
      26,    -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    87,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,   115,    64,    65,
      -1,    -1,    -1,    -1,    -1,   123,   124,   125,   126,   127,
     128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   136,    -1,
      -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   123,   124,   125,
     126,   127,   128,    -1,    -1,    -1,    -1,    -1,    -1,     1,
     136,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,
      22,    -1,    24,    -1,    26,    -1,    -1,    29,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,
      -1,    53,    54,    -1,    56,    -1,    58,    59,    60,    61,
      62,    -1,    64,    65,    -1,    -1,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   123,   124,   125,   126,   127,   128,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,    -1,
      24,    -1,    26,    -1,    -1,    29,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    53,
      54,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      64,    65,    -1,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,   115,   116,    -1,    -1,    -1,    -1,    -1,    -1,   123,
     124,   125,   126,   127,   128,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    87,    88,    -1,    15,
      16,    17,    -1,    -1,    20,    96,    -1,    -1,    24,    -1,
      26,    -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   115,    -1,   117,    -1,    -1,   120,
      -1,    -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    64,    65,
      -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,
       1,    24,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    87,    88,    -1,    15,    16,    17,    -1,    -1,    20,
      96,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,
     116,    -1,    -1,    -1,    -1,    -1,    -1,   123,   124,   125,
     126,   127,   128,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    87,    88,    -1,    15,    16,    17,
      -1,    -1,    20,    96,    -1,    -1,    24,    -1,    26,    -1,
      -1,    29,    30,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,   115,    -1,   117,    96,    -1,   120,    -1,    -1,
      -1,    49,    50,    -1,    -1,    53,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   115,    -1,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    87,
      88,    15,    16,    17,    -1,    -1,    20,    -1,    96,    -1,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,   115,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   123,   124,   125,   126,   127,
     128,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,
      20,    -1,    -1,    -1,    24,    -1,    26,    -1,    -1,    29,
      30,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      50,    -1,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,
      -1,   115,    -1,   117,    64,    65,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,   115,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   123,   124,   125,   126,   127,   128,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,
      -1,    -1,    24,    -1,    26,    -1,    -1,    29,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    53,    54,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    -1,
      20,    -1,    -1,    -1,    24,    -1,    26,    -1,    -1,    29,
      30,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    49,
      50,    -1,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,    64,    65,   118,    -1,    -1,    -1,
      -1,   123,   124,   125,   126,   127,   128,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,   115,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   123,   124,   125,   126,   127,   128,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,    -1,
      24,    -1,    26,    -1,    -1,    29,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    53,
      54,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      64,    65,    -1,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    -1,    -1,    24,    -1,    26,    -1,    -1,    29,    30,
      -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    49,    50,
      -1,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,
     114,   115,   116,    64,    65,    -1,    -1,    -1,    -1,   123,
     124,   125,   126,   127,   128,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,   115,   116,    -1,    -1,    -1,    -1,
      -1,    -1,   123,   124,   125,   126,   127,   128,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,
      -1,    26,    -1,    -1,    29,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    53,    54,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    64,
      65,    -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,
      -1,    -1,    24,    -1,    26,    -1,    -1,    29,    30,    -1,
      -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,
      -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,   114,
     115,   116,    64,    65,    -1,    -1,    -1,    -1,   123,   124,
     125,   126,   127,   128,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,    -1,    -1,    -1,    -1,    -1,
      -1,   123,   124,   125,   126,   127,   128,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,    -1,
      26,    -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    64,    65,
      -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,
      -1,    24,    -1,    26,    -1,    -1,    29,    30,    -1,    -1,
      -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,
      53,    54,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,
     116,    64,    65,    -1,    -1,    -1,    -1,   123,   124,   125,
     126,   127,   128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,   115,   116,    -1,    -1,    -1,    -1,    -1,    -1,
     123,   124,   125,   126,   127,   128,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    -1,    -1,    24,    -1,    26,
      -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    64,    65,    -1,
      -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,    -1,
      24,    -1,    26,    -1,    -1,    29,    30,    -1,    -1,    -1,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    53,
      54,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
      64,    65,    -1,    -1,    -1,    -1,   123,   124,   125,   126,
     127,   128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,   115,   116,    -1,    -1,    -1,    -1,    -1,    -1,   123,
     124,   125,   126,   127,   128,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,
      -1,    -1,    20,    -1,    -1,    -1,    24,    -1,    26,    -1,
      -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    50,    -1,    -1,    53,    54,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    64,    65,    -1,    -1,
      15,    16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,
      -1,    26,    -1,    -1,    29,    30,    -1,    -1,    -1,    87,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    53,    54,
      -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,    64,
      65,    -1,    -1,    -1,    -1,   123,   124,   125,   126,   127,
     128,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    87,    88,    15,    16,    17,    -1,    -1,    20,
      -1,    96,    -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
     115,   116,    -1,    -1,    -1,    -1,    -1,    -1,   123,   124,
     125,   126,   127,   128,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    20,    -1,    -1,    -1,    24,    -1,    26,    -1,    -1,
      29,    30,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      49,    50,    -1,    -1,    53,    54,     3,     4,     5,     6,
       7,     8,     9,    10,   115,    64,    65,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    -1,    -1,    24,    -1,    26,
      -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    87,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,    49,    -1,    -1,    -1,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,   115,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   123,   124,   125,   126,   127,   128,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,    -1,
      -1,   118,    -1,    -1,    -1,    -1,   123,   124,   125,   126,
     127,   128,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    -1,    -1,    24,    -1,    26,    -1,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    53,    54,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    20,    -1,    -1,    -1,    24,    -1,    26,    -1,    -1,
      29,    30,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    53,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,   115,    -1,    -1,   118,    -1,    -1,
      -1,    -1,   123,   124,   125,   126,   127,   128,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,   115,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   123,   124,   125,   126,   127,   128,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,
      -1,    24,    -1,    26,    -1,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      53,    54,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    -1,    -1,    24,    -1,    26,    -1,    -1,    29,    30,
      -1,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,   115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     123,   124,   125,   126,   127,   128,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    20,    -1,    22,    -1,
      -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,   115,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   123,   124,   125,   126,   127,   128,    -1,    -1,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,
      -1,   115,   116,   117,    -1,    -1,    -1,    -1,    -1,   123,
     124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,   116,   117,
      -1,    -1,    -1,    -1,    22,   123,   124,    56,    -1,    58,
      59,    60,    61,    62,    -1,    64,    65,    -1,    -1,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    56,    -1,
      58,    59,    60,    61,    62,    22,    64,    65,    -1,    -1,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    56,
      -1,    58,    59,    60,    61,    62,    -1,    64,    65,   138,
      -1,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      56,    -1,    58,    59,    60,    61,    62,    22,    64,    65,
     138,    -1,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    58,    59,    60,    61,    62,    -1,    64,
      65,   138,    22,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   138,    -1,    -1,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    22,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,
      -1,    22,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,   120,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    22,    25,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,   136,   169,   170,   173,
     174,   177,   178,   180,   183,   184,   185,   192,   195,   246,
     247,   248,   254,   255,   257,   261,   262,   136,    55,    56,
     120,   174,    18,    19,   137,   115,   120,    20,   137,   191,
     174,   174,    20,    26,   115,   123,   124,   136,   175,   176,
     197,   199,   200,   201,   174,   120,   174,   137,    20,    22,
     137,   182,   174,     0,   247,   256,   136,   137,   214,   216,
      18,    19,    27,    69,   121,   250,   251,   252,   253,    26,
     259,   260,   137,   137,   178,   179,    20,   171,   172,     3,
       5,     7,     9,   198,   191,   193,   194,   137,   197,   195,
     196,   200,   119,   136,   135,   249,   115,   117,   199,   199,
     198,   138,   178,   180,   181,   186,   187,   188,   195,   138,
     186,   174,   138,     1,     3,     4,     5,     6,     7,     8,
       9,    10,    15,    16,    17,    20,    23,    24,    29,    30,
      49,    50,    51,    53,    54,    64,    65,    68,    87,    88,
      89,    90,    91,    93,    94,    95,    96,    97,    98,    99,
     100,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   123,   124,   125,   126,   127,
     128,   136,   141,   142,   143,   144,   145,   146,   147,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   164,   165,   166,   168,   169,   174,   210,
     211,   212,   213,   216,   217,   218,   219,   222,   223,   224,
     225,   227,   232,   234,   239,   240,   241,   242,   243,   244,
     245,   260,    20,    20,   174,   119,   121,   120,   115,   169,
     169,   119,   138,   116,   119,   121,   135,   119,   138,   193,
     116,   195,   200,   176,   197,    20,    64,    65,   137,   165,
     208,   216,     1,   116,   174,   202,   203,   204,     1,   118,
     149,   161,   167,   121,   188,   120,   138,   187,   189,   190,
     197,   188,   138,   197,   136,   115,   149,   149,   115,   149,
     166,   115,    50,    50,   137,   167,   134,   115,   115,   115,
     211,   117,   120,   144,    20,   239,   136,   136,   136,   166,
     115,   211,   115,   136,   115,   115,   115,     1,   166,   188,
     205,   149,   149,   150,   150,   150,   150,    28,    29,    30,
     115,   117,   122,   115,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,   135,   124,   129,   130,   125,   126,
      31,    32,    33,    34,   120,   121,    35,    36,   123,   131,
     132,    37,    38,   133,    64,    65,   163,   170,   178,   119,
     136,   211,   138,   211,   215,   115,   115,   115,   115,   115,
     115,   134,   115,   135,   197,   252,   163,   258,     1,   116,
     202,   138,   138,   178,   136,   171,   167,   138,   194,   119,
     138,   208,   209,   116,   119,   115,   117,   197,   200,   201,
     206,   207,   116,   119,   118,   118,   198,   119,   136,   205,
     136,   165,   217,   134,   211,   166,   166,   166,    94,   165,
     144,   115,   136,   136,   166,    94,   166,    21,   140,   140,
       1,   144,   116,   116,   115,   200,   201,   206,   116,    20,
       1,   116,   148,   165,     1,   166,    20,   148,   165,   165,
     165,   165,   165,   165,   165,   165,   165,   165,   165,   150,
     150,   150,   151,   151,   152,   152,   153,   153,   153,   153,
     154,   154,   155,   156,   157,   158,   159,   166,   178,   178,
     115,   117,   178,   165,   168,   218,   221,   221,    20,   226,
     230,   231,   231,    20,   228,    20,   233,   211,     1,   116,
     148,   178,   136,   216,   119,   121,   116,   136,   116,   138,
     119,   138,     1,   116,   202,   206,   118,   167,   135,   207,
     207,   115,   117,   204,   121,   190,   116,   116,   138,   211,
     116,   116,   116,   115,   118,   119,   115,   116,   148,   116,
     115,   116,    21,   116,   119,   119,   116,   116,   119,   150,
     116,   116,   119,   118,   118,   116,   134,   209,   166,   136,
     166,   220,   220,   135,   116,   119,   116,   116,    52,   116,
     116,   163,   136,   136,   138,   208,   116,   116,   118,   208,
     116,   202,   118,   167,   211,   211,   211,   166,   117,   120,
     144,   165,   116,   148,   116,   211,   166,   211,   136,   148,
     166,   148,   165,   161,   116,   119,   118,   136,   116,   166,
     116,   166,    11,    12,    13,    14,   165,   229,   235,   230,
     236,   237,   166,   116,   118,    92,   116,   165,   144,   115,
     118,   119,   121,   116,    92,   116,   116,   116,   116,   211,
     116,   211,   116,   101,   165,   211,   211,   211,   116,   211,
     136,   118,   115,   116,   148,   144,   165,   121,   211,   136,
     136,   136,   211,   211,   165,   238,   117,   144,   116,   148,
     116,   115,   118,   211,   165,   115,   121,   116,   116,   148,
     144,   118,   116,   148,   121,   116,   115,   144,   116,   116,
     148,   115,   116,   116,   148,   116
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   139,   140,   140,   141,   141,   141,   141,   141,   141,
     141,   141,   141,   141,   141,   141,   141,   141,   141,   141,
     141,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   143,   143,   143,
     144,   144,   144,   144,   144,   144,   144,   144,   145,   146,
     147,   147,   147,   147,   147,   147,   147,   148,   148,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   150,   150,   151,   151,   151,   151,   152,
     152,   152,   153,   153,   153,   154,   154,   154,   154,   154,
     155,   155,   155,   156,   156,   157,   157,   158,   158,   159,
     159,   160,   160,   161,   161,   162,   162,   162,   163,   163,
     163,   163,   164,   164,   164,   164,   165,   165,   165,   165,
     165,   165,   165,   165,   165,   165,   165,   165,   166,   166,
     167,   168,   169,   169,   170,   171,   172,   172,   173,   174,
     174,   174,   174,   174,   174,   174,   174,   174,   174,   174,
     175,   175,   176,   176,   177,   177,   177,   177,   177,   178,
     178,   178,   178,   179,   179,   180,   180,   180,   180,   180,
     180,   180,   180,   180,   180,   180,   180,   180,   181,   182,
     182,   183,   184,   184,   184,   184,   184,   185,   186,   186,
     187,   188,   188,   188,   188,   189,   189,   190,   191,   192,
     192,   192,   192,   192,   193,   193,   194,   194,   195,   195,
     195,   195,   195,   195,   195,   195,   195,   195,   195,   195,
     196,   196,   197,   197,   197,   198,   198,   198,   198,   199,
     199,   199,   199,   199,   199,   199,   199,   199,   200,   200,
     200,   200,   201,   202,   203,   203,   203,   204,   204,   204,
     204,   205,   205,   206,   206,   206,   206,   206,   207,   207,
     207,   207,   207,   207,   207,   207,   207,   208,   208,   208,
     209,   209,   210,   211,   211,   212,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   213,   213,
     213,   214,   215,   216,   216,   217,   217,   218,   218,   219,
     219,   219,   219,   219,   220,   220,   221,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   229,   229,   229,   230,
     230,   231,   231,   232,   233,   234,   234,   234,   234,   234,
     234,   234,   234,   235,   234,   236,   234,   237,   234,   238,
     234,   239,   240,   240,   240,   240,   240,   241,   242,   243,
     244,   244,   245,   246,   246,   246,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   249,   248,   250,   250,   251,
     252,   252,   253,   253,   254,   256,   255,   257,   257,   258,
     258,   259,   260,   260,   261,   261,   261,   262,   262
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     5,     4,     8,     7,    10,     9,    11,    10,    12,
      11,    14,    13,     7,     6,    10,     9,     4,     6,     4,
       1,     4,     4,     1,     3,     3,     2,     2,     1,     4,
       1,     3,     4,     4,     3,     4,     4,     1,     3,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     4,     4,     1,     4,     1,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     1,     3,     3,     3,     3,
       1,     3,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     5,     1,     2,     2,     1,     2,
       2,     2,     1,     2,     5,     5,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     3,
       1,     1,     2,     3,     4,     1,     1,     3,     4,     1,
       2,     1,     2,     1,     2,     1,     4,     2,     1,     2,
       1,     3,     1,     3,     1,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       1,     2,     1,     4,     4,     3,     3,     1,     1,     2,
       3,     2,     1,     1,     2,     1,     3,     1,     1,     4,
       5,     5,     6,     2,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     3,     4,     3,     4,     4,     3,     4,     1,     2,
       2,     3,     1,     1,     1,     3,     2,     2,     4,     2,
       1,     1,     2,     1,     1,     2,     1,     2,     3,     2,
       3,     3,     4,     2,     3,     3,     4,     1,     3,     4,
       1,     3,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     3,     4,
       3,     1,     1,     2,     3,     1,     2,     1,     2,     5,
       7,     5,     7,     5,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       4,     1,     3,     1,     1,     5,     5,     7,     7,     6,
       7,     6,     7,     0,     6,     0,     6,     0,     6,     0,
       8,     1,     3,     2,     2,     2,     3,     2,     3,     4,
       5,     7,     7,     1,     2,     2,     1,     1,     1,     1,
       5,     5,     5,     1,     1,     0,     4,     2,     4,     2,
       1,     1,     1,     3,     4,     0,     4,     2,     2,     1,
       3,     1,     4,     1,     7,     6,     7,     6,     6
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* string_constant: TOKEN_STRING_LITERAL  */
#line 298 "src/parse.yy"
                           { (yyval.stringVal) = new std::string(*yylval.stringVal); }
#line 3133 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 3: /* string_constant: string_constant TOKEN_STRING_LITERAL  */
#line 300 "src/parse.yy"
    {
        std::string s = *((std::string *)(yyvsp[-1].stringVal));
        s += *yylval.stringVal;
        (yyval.stringVal) = new std::string(s);
    }
#line 3143 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 4: /* primary_expression: TOKEN_IDENTIFIER  */
#line 308 "src/parse.yy"
                       {
        const char *name = yylval.stringVal->c_str();
        Symbol *s = m->symbolTable->LookupVariable(name);
        (yyval.expr) = NULL;
        if (s)
            (yyval.expr) = new SymbolExpr(s, (yylsp[0]));
        else {
            std::vector<Symbol *> funs;
            m->symbolTable->LookupFunction(name, &funs);
            if (funs.size() > 0)
                (yyval.expr) = new FunctionSymbolExpr(name, funs, (yylsp[0]));
        }
        if ((yyval.expr) == NULL) {
            std::vector<std::string> alternates =
                m->symbolTable->ClosestVariableOrFunctionMatch(name);
            std::string alts = lGetAlternates(alternates);
            Error((yylsp[0]), "Undeclared symbol \"%s\".%s", name, alts.c_str());
        }
    }
#line 3167 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 5: /* primary_expression: TOKEN_INT8_CONSTANT  */
#line 327 "src/parse.yy"
                          {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt8->GetAsConstType(),
                           (int8_t)yylval.intVal, (yylsp[0]));
    }
#line 3176 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 6: /* primary_expression: TOKEN_UINT8_CONSTANT  */
#line 331 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt8->GetAsConstType(),
                           (uint8_t)yylval.intVal, (yylsp[0]));
    }
#line 3185 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 7: /* primary_expression: TOKEN_INT16_CONSTANT  */
#line 335 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt16->GetAsConstType(),
                           (int16_t)yylval.intVal, (yylsp[0]));
    }
#line 3194 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 8: /* primary_expression: TOKEN_UINT16_CONSTANT  */
#line 339 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt16->GetAsConstType(),
                           (uint16_t)yylval.intVal, (yylsp[0]));
    }
#line 3203 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 9: /* primary_expression: TOKEN_INT32_CONSTANT  */
#line 343 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 3212 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 10: /* primary_expression: TOKEN_UINT32_CONSTANT  */
#line 347 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 3221 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 11: /* primary_expression: TOKEN_INT64_CONSTANT  */
#line 351 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 3230 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 12: /* primary_expression: TOKEN_UINT64_CONSTANT  */
#line 355 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 3239 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 13: /* primary_expression: TOKEN_FLOAT16_CONSTANT  */
#line 359 "src/parse.yy"
                             {
         std::string sval = *(yylval.stringVal);
         llvm::Type *hType = llvm::Type::getHalfTy(*g->ctx);
         const llvm::fltSemantics &FS = hType->getFltSemantics();
         llvm::APFloat f16(FS, sval);
         (yyval.expr) = new ConstExpr(AtomicType::UniformFloat16->GetAsConstType(),
                           f16, (yylsp[0]));
    }
#line 3252 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 14: /* primary_expression: TOKEN_FLOAT_CONSTANT  */
#line 367 "src/parse.yy"
                           {
        llvm::APFloat f(yylval.floatVal);
        (yyval.expr) = new ConstExpr(AtomicType::UniformFloat->GetAsConstType(),
                           f, (yylsp[0]));
    }
#line 3262 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 15: /* primary_expression: TOKEN_DOUBLE_CONSTANT  */
#line 372 "src/parse.yy"
                            {
        llvm::APFloat d(yylval.doubleVal);
        (yyval.expr) = new ConstExpr(AtomicType::UniformDouble->GetAsConstType(),
                           d, (yylsp[0]));
    }
#line 3272 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 16: /* primary_expression: TOKEN_TRUE  */
#line 377 "src/parse.yy"
                 {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), true, (yylsp[0]));
    }
#line 3280 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 17: /* primary_expression: TOKEN_FALSE  */
#line 380 "src/parse.yy"
                  {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), false, (yylsp[0]));
    }
#line 3288 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 18: /* primary_expression: TOKEN_NULL  */
#line 383 "src/parse.yy"
                 {
        (yyval.expr) = new NullPointerExpr((yylsp[0]));
    }
#line 3296 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 19: /* primary_expression: '(' expression ')'  */
#line 388 "src/parse.yy"
                         { (yyval.expr) = (yyvsp[-1].expr); }
#line 3302 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 20: /* primary_expression: '(' error ')'  */
#line 389 "src/parse.yy"
                    { (yyval.expr) = NULL; }
#line 3308 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 21: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' argument_expression_list ')'  */
#line 394 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]), (yylsp[0])), true, launchCount);
      }
#line 3318 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 22: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' ')'  */
#line 400 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-1]),(yylsp[0]))), Union((yylsp[-2]), (yylsp[0])), true, launchCount);
       }
#line 3328 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 23: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 407 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3338 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 24: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 413 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3348 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 25: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 420 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-7].expr), (yyvsp[-5].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3358 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 26: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 426 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-6].expr), (yyvsp[-4].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3368 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 27: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 432 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3378 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 28: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 438 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3388 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 29: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 445 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-9].expr), (yyvsp[-7].expr), (yyvsp[-5].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3397 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 30: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 450 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3406 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 31: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 455 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), (yyvsp[-11].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3415 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 32: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 460 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), (yyvsp[-10].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3424 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 33: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 467 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3434 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 34: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' ')' '>'  */
#line 473 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3444 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 35: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 479 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3454 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 36: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' ')' '>'  */
#line 485 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3464 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 37: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' postfix_expression ')'  */
#line 494 "src/parse.yy"
      {
          (yyval.expr) = new FunctionCallExpr((yyvsp[-1].expr), new ExprList((yylsp[0])), Union((yylsp[-3]),(yylsp[0])), false, NULL, true);
      }
#line 3472 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 38: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' postfix_expression ',' argument_expression_list ')'  */
#line 498 "src/parse.yy"
      {
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-5]),(yylsp[0])), false, NULL, true);
      }
#line 3480 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 39: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' error ')'  */
#line 502 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3486 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 41: /* postfix_expression: postfix_expression '[' expression ']'  */
#line 508 "src/parse.yy"
      { (yyval.expr) = new IndexExpr((yyvsp[-3].expr), (yyvsp[-1].expr), Union((yylsp[-3]),(yylsp[0]))); }
#line 3492 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 42: /* postfix_expression: postfix_expression '[' error ']'  */
#line 510 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3498 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 44: /* postfix_expression: postfix_expression '.' TOKEN_IDENTIFIER  */
#line 513 "src/parse.yy"
      { (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false); }
#line 3504 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 45: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_IDENTIFIER  */
#line 515 "src/parse.yy"
      { (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true); }
#line 3510 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 46: /* postfix_expression: postfix_expression TOKEN_INC_OP  */
#line 517 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostInc, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3516 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 47: /* postfix_expression: postfix_expression TOKEN_DEC_OP  */
#line 519 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostDec, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3522 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 48: /* intrinsic_name: TOKEN_INTRINSIC_CALL  */
#line 524 "src/parse.yy"
      {
          (yyval.stringVal) = yylval.stringVal;
      }
#line 3530 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 49: /* intrincall_expression: intrinsic_name '(' argument_expression_list ')'  */
#line 531 "src/parse.yy"
      {
          std::string *name = (yyvsp[-3].stringVal);
          name->erase(0, 1);
          Symbol* sym = m->AddLLVMIntrinsicDecl(*name, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          const char *fname = name->c_str();
          const std::vector<Symbol *> funcs{sym};
          FunctionSymbolExpr *fSym = NULL;
          if (sym != NULL)
              fSym = new FunctionSymbolExpr(fname, funcs, (yylsp[-3]));
          (yyval.expr) = new FunctionCallExpr(fSym, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));

      }
#line 3547 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 51: /* funcall_expression: postfix_expression '(' ')'  */
#line 548 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0]))); }
#line 3553 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 52: /* funcall_expression: postfix_expression '(' argument_expression_list ')'  */
#line 550 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0]))); }
#line 3559 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 53: /* funcall_expression: postfix_expression '(' error ')'  */
#line 552 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3565 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 54: /* funcall_expression: simple_template_id '(' ')'  */
#line 554 "src/parse.yy"
      {
          // Create FunctionSymbolExpr with a candidate functions list
          Expr *functionSymbolExpr = nullptr;
          std::vector<TemplateSymbol *> funcTempls;
          const std::string name = (yyvsp[-2].simpleTemplateID)->first->name;
          m->symbolTable->LookupFunctionTemplate(name, &funcTempls);
          if (funcTempls.size() > 0) {
              std::vector<std::pair<const Type *, SourcePos>> *templArgs = (yyvsp[-2].simpleTemplateID)->second;
              Assert(templArgs);
              functionSymbolExpr = new FunctionSymbolExpr(name.c_str(), funcTempls, *templArgs, (yylsp[-2]));
              (yyval.expr) = new FunctionCallExpr(functionSymbolExpr, new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])));
          } else {
              Error((yylsp[-2]), "No matching template functions were declared.");
              (yyval.expr) = nullptr;
          }
      }
#line 3586 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 55: /* funcall_expression: simple_template_id '(' argument_expression_list ')'  */
#line 571 "src/parse.yy"
      {
          // Create FunctionSymbolExpr with a candidate functions list
          Expr *functionSymbolExpr = nullptr;
          std::vector<TemplateSymbol *> funcTempls;
          const std::string name = (yyvsp[-3].simpleTemplateID)->first->name;
          m->symbolTable->LookupFunctionTemplate(name, &funcTempls);
          if (funcTempls.size() > 0) {
              std::vector<std::pair<const Type *, SourcePos>> *templArgs = (yyvsp[-3].simpleTemplateID)->second;
              Assert(templArgs);
              functionSymbolExpr = new FunctionSymbolExpr(name.c_str(), funcTempls, *templArgs, (yylsp[-3]));
              (yyval.expr) = new FunctionCallExpr(functionSymbolExpr, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          } else {
              Error((yylsp[-3]), "No matching template functions were declared.");
              (yyval.expr) = nullptr;
          }
      }
#line 3607 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 56: /* funcall_expression: simple_template_id '(' error ')'  */
#line 588 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3613 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 57: /* argument_expression_list: assignment_expression  */
#line 592 "src/parse.yy"
                                 { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 3619 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 58: /* argument_expression_list: argument_expression_list ',' assignment_expression  */
#line 594 "src/parse.yy"
      {
          ExprList *argList = llvm::dyn_cast<ExprList>((yyvsp[-2].exprList));
          if (argList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              argList = new ExprList((yylsp[0]));
          }
          argList->exprs.push_back((yyvsp[0].expr));
          argList->pos = Union(argList->pos, (yylsp[0]));
          (yyval.exprList) = argList;
      }
#line 3634 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 62: /* unary_expression: TOKEN_INC_OP unary_expression  */
#line 611 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreInc, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3640 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 63: /* unary_expression: TOKEN_DEC_OP unary_expression  */
#line 613 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreDec, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3646 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 64: /* unary_expression: '&' unary_expression  */
#line 615 "src/parse.yy"
      { (yyval.expr) = new AddressOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3652 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 65: /* unary_expression: '*' unary_expression  */
#line 617 "src/parse.yy"
      { (yyval.expr) = new PtrDerefExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3658 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 66: /* unary_expression: '+' cast_expression  */
#line 619 "src/parse.yy"
      { (yyval.expr) = (yyvsp[0].expr); }
#line 3664 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 67: /* unary_expression: '-' cast_expression  */
#line 621 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::Negate, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3670 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 68: /* unary_expression: '~' cast_expression  */
#line 623 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::BitNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3676 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 69: /* unary_expression: '!' cast_expression  */
#line 625 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::LogicalNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3682 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 70: /* unary_expression: TOKEN_SIZEOF unary_expression  */
#line 627 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3688 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 71: /* unary_expression: TOKEN_SIZEOF '(' type_name ')'  */
#line 629 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[-1].type), Union((yylsp[-3]), (yylsp[0]))); }
#line 3694 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 72: /* unary_expression: TOKEN_ALLOCA '(' assignment_expression ')'  */
#line 631 "src/parse.yy"
      {
          (yyval.expr) = new AllocaExpr((yyvsp[-1].expr), Union((yylsp[-3]), (yylsp[0])));
      }
#line 3702 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 74: /* cast_expression: '(' type_name ')' cast_expression  */
#line 639 "src/parse.yy"
      {
          (yyval.expr) = new TypeCastExpr((yyvsp[-2].type), (yyvsp[0].expr), Union((yylsp[-3]),(yylsp[0])));
      }
#line 3710 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 76: /* multiplicative_expression: multiplicative_expression '*' cast_expression  */
#line 647 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mul, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3716 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 77: /* multiplicative_expression: multiplicative_expression '/' cast_expression  */
#line 649 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Div, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3722 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 78: /* multiplicative_expression: multiplicative_expression '%' cast_expression  */
#line 651 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mod, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3728 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 80: /* additive_expression: additive_expression '+' multiplicative_expression  */
#line 657 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Add, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3734 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 81: /* additive_expression: additive_expression '-' multiplicative_expression  */
#line 659 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Sub, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3740 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 83: /* shift_expression: shift_expression TOKEN_LEFT_OP additive_expression  */
#line 665 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shl, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3746 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 84: /* shift_expression: shift_expression TOKEN_RIGHT_OP additive_expression  */
#line 667 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3752 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 86: /* relational_expression: relational_expression '<' shift_expression  */
#line 673 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Lt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3758 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 87: /* relational_expression: relational_expression '>' shift_expression  */
#line 675 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Gt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3764 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 88: /* relational_expression: relational_expression TOKEN_LE_OP shift_expression  */
#line 677 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Le, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3770 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 89: /* relational_expression: relational_expression TOKEN_GE_OP shift_expression  */
#line 679 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Ge, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3776 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 91: /* equality_expression: equality_expression TOKEN_EQ_OP relational_expression  */
#line 685 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Equal, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3782 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 92: /* equality_expression: equality_expression TOKEN_NE_OP relational_expression  */
#line 687 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::NotEqual, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3788 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 94: /* and_expression: and_expression '&' equality_expression  */
#line 693 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3794 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 96: /* exclusive_or_expression: exclusive_or_expression '^' and_expression  */
#line 699 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitXor, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3800 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 98: /* inclusive_or_expression: inclusive_or_expression '|' exclusive_or_expression  */
#line 705 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3806 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 100: /* logical_and_expression: logical_and_expression TOKEN_AND_OP inclusive_or_expression  */
#line 711 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3812 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 102: /* logical_or_expression: logical_or_expression TOKEN_OR_OP logical_and_expression  */
#line 717 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3818 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 104: /* conditional_expression: logical_or_expression '?' expression ':' conditional_expression  */
#line 723 "src/parse.yy"
      { (yyval.expr) = new SelectExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-4]),(yylsp[0]))); }
#line 3824 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 105: /* rate_qualified_new: TOKEN_NEW  */
#line 727 "src/parse.yy"
                { (yyval.intVal) = 0; }
#line 3830 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 106: /* rate_qualified_new: TOKEN_UNIFORM TOKEN_NEW  */
#line 728 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_UNIFORM; }
#line 3836 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 107: /* rate_qualified_new: TOKEN_VARYING TOKEN_NEW  */
#line 729 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_VARYING; }
#line 3842 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 108: /* rate_qualified_type_specifier: type_specifier  */
#line 733 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].type); }
#line 3848 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 109: /* rate_qualified_type_specifier: TOKEN_UNIFORM type_specifier  */
#line 735 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
            (yyval.type) = NULL;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
    }
#line 3863 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 110: /* rate_qualified_type_specifier: TOKEN_VARYING type_specifier  */
#line 746 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
            (yyval.type) = NULL;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
    }
#line 3878 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 111: /* rate_qualified_type_specifier: soa_width_specifier type_specifier  */
#line 757 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else {
            int soaWidth = (int)(yyvsp[-1].intVal);
            const StructType *st = CastType<StructType>((yyvsp[0].type));
            if (st == NULL) {
                Error((yylsp[-1]), "\"soa\" qualifier is illegal with non-struct type \"%s\".",
                      (yyvsp[0].type)->GetString().c_str());
                (yyval.type) = NULL;
            }
            else if (soaWidth <= 0 || (soaWidth & (soaWidth - 1)) != 0) {
                Error((yylsp[-1]), "soa<%d> width illegal. Value must be positive power "
                      "of two.", soaWidth);
                (yyval.type) = NULL;
            }
            else
                (yyval.type) = st->GetAsSOAType(soaWidth);
        }
    }
#line 3903 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 113: /* new_expression: rate_qualified_new rate_qualified_type_specifier  */
#line 782 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-1].intVal), (yyvsp[0].type), NULL, NULL, (yylsp[-1]), Union((yylsp[-1]), (yylsp[0])));
    }
#line 3911 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 114: /* new_expression: rate_qualified_new rate_qualified_type_specifier '(' initializer_list ')'  */
#line 786 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), (yyvsp[-1].exprList), NULL, (yylsp[-4]), Union((yylsp[-4]), (yylsp[-3])));
    }
#line 3919 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 115: /* new_expression: rate_qualified_new rate_qualified_type_specifier '[' expression ']'  */
#line 790 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), NULL, (yyvsp[-1].expr), (yylsp[-4]), Union((yylsp[-4]), (yylsp[-1])));
    }
#line 3927 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 117: /* assignment_expression: unary_expression '=' assignment_expression  */
#line 798 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::Assign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3933 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 118: /* assignment_expression: unary_expression TOKEN_MUL_ASSIGN assignment_expression  */
#line 800 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::MulAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3939 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 119: /* assignment_expression: unary_expression TOKEN_DIV_ASSIGN assignment_expression  */
#line 802 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::DivAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3945 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 120: /* assignment_expression: unary_expression TOKEN_MOD_ASSIGN assignment_expression  */
#line 804 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ModAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3951 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 121: /* assignment_expression: unary_expression TOKEN_ADD_ASSIGN assignment_expression  */
#line 806 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AddAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3957 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 122: /* assignment_expression: unary_expression TOKEN_SUB_ASSIGN assignment_expression  */
#line 808 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::SubAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3963 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 123: /* assignment_expression: unary_expression TOKEN_LEFT_ASSIGN assignment_expression  */
#line 810 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShlAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3969 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 124: /* assignment_expression: unary_expression TOKEN_RIGHT_ASSIGN assignment_expression  */
#line 812 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3975 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 125: /* assignment_expression: unary_expression TOKEN_AND_ASSIGN assignment_expression  */
#line 814 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AndAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3981 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 126: /* assignment_expression: unary_expression TOKEN_XOR_ASSIGN assignment_expression  */
#line 816 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::XorAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3987 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 127: /* assignment_expression: unary_expression TOKEN_OR_ASSIGN assignment_expression  */
#line 818 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::OrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3993 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 129: /* expression: expression ',' assignment_expression  */
#line 824 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Comma, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3999 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 131: /* declaration_statement: declaration  */
#line 833 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) == NULL) {
            AssertPos((yylsp[0]), m->errorCount > 0);
            (yyval.stmt) = NULL;
        }
        else if ((yyvsp[0].declaration)->declSpecs->storageClass == SC_TYPEDEF) {
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i) {
                if ((yyvsp[0].declaration)->declarators[i] == NULL)
                    AssertPos((yylsp[0]), m->errorCount > 0);
                else
                    m->AddTypeDef((yyvsp[0].declaration)->declarators[i]->name,
                                  (yyvsp[0].declaration)->declarators[i]->type,
                                  (yyvsp[0].declaration)->declarators[i]->pos);
            }
            (yyval.stmt) = NULL;
        }
        else {
            (yyvsp[0].declaration)->DeclareFunctions();
            std::vector<VariableDeclaration> vars = (yyvsp[0].declaration)->GetVariableDeclarations();
            (yyval.stmt) = new DeclStmt(vars, (yylsp[0]));
        }
    }
#line 4026 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 132: /* declaration: declaration_specifiers ';'  */
#line 859 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs));
      }
#line 4034 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 133: /* declaration: declaration_specifiers init_declarator_list ';'  */
#line 863 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-2].declSpecs), (yyvsp[-1].declarators));
      }
#line 4042 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 134: /* soa_width_specifier: TOKEN_SOA '<' int_constant '>'  */
#line 870 "src/parse.yy"
      { (yyval.intVal) = (yyvsp[-1].intVal); }
#line 4048 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 135: /* declspec_item: TOKEN_IDENTIFIER  */
#line 875 "src/parse.yy"
    {
        std::pair<std::string, SourcePos> *p = new std::pair<std::string, SourcePos>;
        p->first = *(yylval.stringVal);
        p->second = (yylsp[0]);
        (yyval.declspecPair) = p;
    }
#line 4059 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 136: /* declspec_list: declspec_item  */
#line 885 "src/parse.yy"
    {
        (yyval.declspecList) = new std::vector<std::pair<std::string, SourcePos> >;
        (yyval.declspecList)->push_back(*(yyvsp[0].declspecPair));
    }
#line 4068 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 137: /* declspec_list: declspec_list ',' declspec_item  */
#line 890 "src/parse.yy"
    {
        if ((yyvsp[-2].declspecList) != NULL)
            (yyvsp[-2].declspecList)->push_back(*(yyvsp[0].declspecPair));
        (yyval.declspecList) = (yyvsp[-2].declspecList);
    }
#line 4078 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 138: /* declspec_specifier: TOKEN_DECLSPEC '(' declspec_list ')'  */
#line 899 "src/parse.yy"
    {
        (yyval.declspecList) = (yyvsp[-1].declspecList);
    }
#line 4086 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 139: /* declaration_specifiers: storage_class_specifier  */
#line 906 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(NULL, (yyvsp[0].storageClass));
      }
#line 4094 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 140: /* declaration_specifiers: storage_class_specifier declaration_specifiers  */
#line 910 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->storageClass != SC_NONE)
                  Error((yylsp[-1]), "Multiple storage class specifiers in a declaration are illegal. "
                        "(Have provided both \"%s\" and \"%s\".)",
                        lGetStorageClassString(ds->storageClass),
                        lGetStorageClassString((yyvsp[-1].storageClass)));
              else
                  ds->storageClass = (yyvsp[-1].storageClass);
          }
          (yyval.declSpecs) = ds;
      }
#line 4112 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 141: /* declaration_specifiers: declspec_specifier  */
#line 924 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs;
          if ((yyvsp[0].declspecList) != NULL)
              (yyval.declSpecs)->declSpecList = *(yyvsp[0].declspecList);
      }
#line 4122 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 142: /* declaration_specifiers: declspec_specifier declaration_specifiers  */
#line 930 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          std::vector<std::pair<std::string, SourcePos> > *declSpecList = (yyvsp[-1].declspecList);
          if (ds != NULL && declSpecList != NULL) {
              for (int i = 0; i < (int)declSpecList->size(); ++i)
                  ds->declSpecList.push_back((*declSpecList)[i]);
          }
          (yyval.declSpecs) = ds;
      }
#line 4136 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 143: /* declaration_specifiers: soa_width_specifier  */
#line 940 "src/parse.yy"
      {
          DeclSpecs *ds = new DeclSpecs;
          ds->soaWidth = (int32_t)(yyvsp[0].intVal);
          (yyval.declSpecs) = ds;
      }
#line 4146 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 144: /* declaration_specifiers: soa_width_specifier declaration_specifiers  */
#line 946 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->soaWidth != 0)
                  Error((yylsp[-1]), "soa<> qualifier supplied multiple times in declaration.");
              else
                  ds->soaWidth = (int32_t)(yyvsp[-1].intVal);
          }
          (yyval.declSpecs) = ds;
      }
#line 4161 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 145: /* declaration_specifiers: type_specifier  */
#line 957 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs((yyvsp[0].type));
      }
#line 4169 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 146: /* declaration_specifiers: type_specifier '<' int_constant '>'  */
#line 961 "src/parse.yy"
    {
          DeclSpecs *ds = new DeclSpecs((yyvsp[-3].type));
          ds->vectorSize = (int32_t)(yyvsp[-1].intVal);
          (yyval.declSpecs) = ds;
    }
#line 4179 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 147: /* declaration_specifiers: type_specifier declaration_specifiers  */
#line 967 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->baseType != NULL) {
                  if( ds->baseType->IsUnsignedType()) {
                      Error((yylsp[-1]), "Redefining uint8/uint16/uint32/uint64 type "
                      "which is part of ISPC language since version 1.13. "
                      "Remove this typedef or use ISPC_UINT_IS_DEFINED to "
                      "detect that these types are defined.");
                  }
                  else
                      Error((yylsp[-1]), "Multiple types provided for declaration.");
              }
              ds->baseType = (yyvsp[-1].type);
          }
          (yyval.declSpecs) = ds;
      }
#line 4201 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 148: /* declaration_specifiers: type_qualifier  */
#line 985 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(NULL, SC_NONE, (yyvsp[0].typeQualifier));
      }
#line 4209 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 149: /* declaration_specifiers: type_qualifier declaration_specifiers  */
#line 989 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL)
              ds->typeQualifiers |= (yyvsp[-1].typeQualifier);
          (yyval.declSpecs) = ds;
      }
#line 4220 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 150: /* init_declarator_list: init_declarator  */
#line 999 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != NULL)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 4231 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 151: /* init_declarator_list: init_declarator_list ',' init_declarator  */
#line 1006 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = (std::vector<Declarator *> *)(yyvsp[-2].declarators);
          if (dl == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              dl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != NULL)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 4246 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 153: /* init_declarator: declarator '=' initializer  */
#line 1021 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != NULL)
              (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
          (yyval.declarator) = (yyvsp[-2].declarator);
      }
#line 4256 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 154: /* storage_class_specifier: TOKEN_TYPEDEF  */
#line 1029 "src/parse.yy"
                    { (yyval.storageClass) = SC_TYPEDEF; }
#line 4262 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 155: /* storage_class_specifier: TOKEN_EXTERN  */
#line 1030 "src/parse.yy"
                   { (yyval.storageClass) = SC_EXTERN; }
#line 4268 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 156: /* storage_class_specifier: TOKEN_EXTERN TOKEN_STRING_C_LITERAL  */
#line 1031 "src/parse.yy"
                                           { (yyval.storageClass) = SC_EXTERN_C; }
#line 4274 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 157: /* storage_class_specifier: TOKEN_EXTERN TOKEN_STRING_SYCL_LITERAL  */
#line 1032 "src/parse.yy"
                                              { (yyval.storageClass) = SC_EXTERN_SYCL; }
#line 4280 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 158: /* storage_class_specifier: TOKEN_STATIC  */
#line 1033 "src/parse.yy"
                   { (yyval.storageClass) = SC_STATIC; }
#line 4286 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 159: /* type_specifier: atomic_var_type_specifier  */
#line 1037 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].atomicType); }
#line 4292 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 160: /* type_specifier: TOKEN_TYPE_NAME  */
#line 1039 "src/parse.yy"
    {
        const Type *t = m->symbolTable->LookupType(yytext);
        (yyval.type) = t;
    }
#line 4301 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 161: /* type_specifier: struct_or_union_specifier  */
#line 1043 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].type); }
#line 4307 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 162: /* type_specifier: enum_specifier  */
#line 1044 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].enumType); }
#line 4313 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 163: /* type_specifier_list: type_specifier  */
#line 1049 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.typeList) = NULL;
        else {
            std::vector<std::pair<const Type *, SourcePos> > *vec =
                new std::vector<std::pair<const Type *, SourcePos> >;
            vec->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
            (yyval.typeList) = vec;
        }
    }
#line 4328 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 164: /* type_specifier_list: type_specifier_list ',' type_specifier  */
#line 1060 "src/parse.yy"
    {
        (yyval.typeList) = (yyvsp[-2].typeList);
        if ((yyvsp[-2].typeList) == NULL)
            Assert(m->errorCount > 0);
        else
            (yyval.typeList)->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
    }
#line 4340 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 165: /* atomic_var_type_specifier: TOKEN_VOID  */
#line 1070 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::Void; }
#line 4346 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 166: /* atomic_var_type_specifier: TOKEN_BOOL  */
#line 1071 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformBool->GetAsUnboundVariabilityType(); }
#line 4352 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 167: /* atomic_var_type_specifier: TOKEN_INT8  */
#line 1072 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformInt8->GetAsUnboundVariabilityType(); }
#line 4358 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 168: /* atomic_var_type_specifier: TOKEN_UINT8  */
#line 1073 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformUInt8->GetAsUnboundVariabilityType(); }
#line 4364 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 169: /* atomic_var_type_specifier: TOKEN_INT16  */
#line 1074 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt16->GetAsUnboundVariabilityType(); }
#line 4370 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 170: /* atomic_var_type_specifier: TOKEN_UINT16  */
#line 1075 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt16->GetAsUnboundVariabilityType(); }
#line 4376 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 171: /* atomic_var_type_specifier: TOKEN_INT  */
#line 1076 "src/parse.yy"
                { (yyval.atomicType) = AtomicType::UniformInt32->GetAsUnboundVariabilityType(); }
#line 4382 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 172: /* atomic_var_type_specifier: TOKEN_UINT  */
#line 1077 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformUInt32->GetAsUnboundVariabilityType(); }
#line 4388 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 173: /* atomic_var_type_specifier: TOKEN_FLOAT16  */
#line 1078 "src/parse.yy"
                    { (yyval.atomicType) = AtomicType::UniformFloat16->GetAsUnboundVariabilityType(); }
#line 4394 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 174: /* atomic_var_type_specifier: TOKEN_FLOAT  */
#line 1079 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformFloat->GetAsUnboundVariabilityType(); }
#line 4400 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 175: /* atomic_var_type_specifier: TOKEN_DOUBLE  */
#line 1080 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformDouble->GetAsUnboundVariabilityType(); }
#line 4406 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 176: /* atomic_var_type_specifier: TOKEN_INT64  */
#line 1081 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt64->GetAsUnboundVariabilityType(); }
#line 4412 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 177: /* atomic_var_type_specifier: TOKEN_UINT64  */
#line 1082 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt64->GetAsUnboundVariabilityType(); }
#line 4418 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 178: /* short_vec_specifier: atomic_var_type_specifier '<' int_constant '>'  */
#line 1087 "src/parse.yy"
    {
        (yyval.type) = (yyvsp[-3].atomicType) ? new VectorType((yyvsp[-3].atomicType), (int32_t)(yyvsp[-1].intVal)) : NULL;
    }
#line 4426 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 179: /* struct_or_union_name: TOKEN_IDENTIFIER  */
#line 1093 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 4432 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 180: /* struct_or_union_name: TOKEN_TYPE_NAME  */
#line 1094 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 4438 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 181: /* struct_or_union_and_name: struct_or_union struct_or_union_name  */
#line 1099 "src/parse.yy"
      {
          const Type *st = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (st == NULL) {
              st = new UndefinedStructType((yyvsp[0].constCharPtr), Variability::Unbound, false, (yylsp[0]));
              m->symbolTable->AddType((yyvsp[0].constCharPtr), st, (yylsp[0]));
              (yyval.type) = st;
          }
          else {
              if (CastType<StructType>(st) == NULL &&
                  CastType<UndefinedStructType>(st) == NULL) {
                  Error((yylsp[0]), "Type \"%s\" is not a struct type! (%s)", (yyvsp[0].constCharPtr),
                        st->GetString().c_str());
                  (yyval.type) = NULL;
              }
              else
                  (yyval.type) = st;
         }
      }
#line 4461 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 183: /* struct_or_union_specifier: struct_or_union_and_name '{' struct_declaration_list '}'  */
#line 1122 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != NULL) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              const std::string &name = CastType<StructType>((yyvsp[-3].type)) ?
                  CastType<StructType>((yyvsp[-3].type))->GetStructName() :
                  CastType<UndefinedStructType>((yyvsp[-3].type))->GetStructName();
              StructType *st = new StructType(name, elementTypes, elementNames,
                                              elementPositions, false,
                                              Variability::Unbound, false, (yylsp[-3]));
              m->symbolTable->AddType(name.c_str(), st, (yylsp[-3]));
              (yyval.type) = st;
          }
          else
              (yyval.type) = NULL;
      }
#line 4485 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 184: /* struct_or_union_specifier: struct_or_union '{' struct_declaration_list '}'  */
#line 1142 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != NULL) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                                  false, Variability::Unbound, true, (yylsp[-3]));
          }
          else
              (yyval.type) = NULL;
      }
#line 4503 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 185: /* struct_or_union_specifier: struct_or_union '{' '}'  */
#line 1156 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                              false, Variability::Unbound, true, (yylsp[-2]));
      }
#line 4515 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 186: /* struct_or_union_specifier: struct_or_union_and_name '{' '}'  */
#line 1164 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          const std::string &name = CastType<StructType>((yyvsp[-2].type)) ?
              CastType<StructType>((yyvsp[-2].type))->GetStructName() :
              CastType<UndefinedStructType>((yyvsp[-2].type))->GetStructName();
          StructType *st = new StructType(name, elementTypes,
                                          elementNames, elementPositions,
                                          false, Variability::Unbound, false, (yylsp[-2]));
          m->symbolTable->AddType(name.c_str(), st, (yylsp[-1]));
          (yyval.type) = st;
      }
#line 4533 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 188: /* struct_declaration_list: struct_declaration  */
#line 1185 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = new std::vector<StructDeclaration *>;
          if ((yyvsp[0].structDeclaration) != NULL)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4544 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 189: /* struct_declaration_list: struct_declaration_list struct_declaration  */
#line 1192 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = (std::vector<StructDeclaration *> *)(yyvsp[-1].structDeclarationList);
          if (sdl == NULL) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sdl = new std::vector<StructDeclaration *>;
          }
          if ((yyvsp[0].structDeclaration) != NULL)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4559 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 190: /* struct_declaration: specifier_qualifier_list struct_declarator_list ';'  */
#line 1206 "src/parse.yy"
      { (yyval.structDeclaration) = ((yyvsp[-2].type) != NULL && (yyvsp[-1].structDeclaratorList) != NULL) ? new StructDeclaration((yyvsp[-2].type), (yyvsp[-1].structDeclaratorList)) : NULL; }
#line 4565 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 194: /* specifier_qualifier_list: type_qualifier specifier_qualifier_list  */
#line 1214 "src/parse.yy"
    {
        if ((yyvsp[0].type) != NULL) {
            if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNIFORM) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = NULL;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VARYING) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = NULL;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_CONST)
                (yyval.type) = (yyvsp[0].type)->GetAsConstType();
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_SIGNED) {
                if ((yyvsp[0].type)->IsIntType() == false) {
                    Error((yylsp[-1]), "Can't apply \"signed\" qualifier to \"%s\" type.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNSIGNED) {
                const Type *t = (yyvsp[0].type)->GetAsUnsignedType();
                if (t)
                    (yyval.type) = t;
                else {
                    Error((yylsp[-1]), "Can't apply \"unsigned\" qualifier to \"%s\" type. Ignoring.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_INLINE) {
                Error((yylsp[-1]), "\"inline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_NOINLINE) {
                Error((yylsp[-1]), "\"noinline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VECTORCALL) {
                Error((yylsp[-1]), "\"__vectorcall\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_REGCALL) {
                Error((yylsp[-1]), "\"__regcall\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_TASK) {
                Error((yylsp[-1]), "\"task\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNMASKED) {
                Error((yylsp[-1]), "\"unmasked\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_EXPORT) {
                Error((yylsp[-1]), "\"export\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else
                FATAL("Unhandled type qualifier in parser.");
        }
        else {
            if (m->errorCount == 0)
                Error((yylsp[-1]), "Lost type qualifier in parser.");
            (yyval.type) = NULL;
        }
    }
#line 4651 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 195: /* struct_declarator_list: struct_declarator  */
#line 1300 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != NULL)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4662 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 196: /* struct_declarator_list: struct_declarator_list ',' struct_declarator  */
#line 1307 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = (std::vector<Declarator *> *)(yyvsp[-2].structDeclaratorList);
          if (sdl == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              sdl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != NULL)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4677 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 197: /* struct_declarator: declarator  */
#line 1320 "src/parse.yy"
                 { (yyval.declarator) = (yyvsp[0].declarator); }
#line 4683 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 198: /* enum_identifier: TOKEN_IDENTIFIER  */
#line 1328 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 4689 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 199: /* enum_specifier: TOKEN_ENUM '{' enumerator_list '}'  */
#line 1332 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(NULL, (yyvsp[-1].symbolList), (yylsp[-3]));
      }
#line 4697 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 200: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list '}'  */
#line 1336 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-3].constCharPtr), (yyvsp[-1].symbolList), (yylsp[-3]));
      }
#line 4705 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 201: /* enum_specifier: TOKEN_ENUM '{' enumerator_list ',' '}'  */
#line 1340 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(NULL, (yyvsp[-2].symbolList), (yylsp[-4]));
      }
#line 4713 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 202: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list ',' '}'  */
#line 1344 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-4].constCharPtr), (yyvsp[-2].symbolList), (yylsp[-4]));
      }
#line 4721 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 203: /* enum_specifier: TOKEN_ENUM enum_identifier  */
#line 1348 "src/parse.yy"
      {
          const Type *type = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (type == NULL) {
              std::vector<std::string> alternates = m->symbolTable->ClosestEnumTypeMatch((yyvsp[0].constCharPtr));
              std::string alts = lGetAlternates(alternates);
              Error((yylsp[0]), "Enum type \"%s\" unknown.%s", (yyvsp[0].constCharPtr), alts.c_str());
              (yyval.enumType) = NULL;
          }
          else {
              const EnumType *enumType = CastType<EnumType>(type);
              if (enumType == NULL) {
                  Error((yylsp[0]), "Type \"%s\" is not an enum type (%s).", (yyvsp[0].constCharPtr),
                        type->GetString().c_str());
                  (yyval.enumType) = NULL;
              }
              else
                  (yyval.enumType) = enumType;
          }
      }
#line 4745 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 204: /* enumerator_list: enumerator  */
#line 1371 "src/parse.yy"
      {
          if ((yyvsp[0].symbol) == NULL)
              (yyval.symbolList) = NULL;
          else {
              std::vector<Symbol *> *el = new std::vector<Symbol *>;
              el->push_back((yyvsp[0].symbol));
              (yyval.symbolList) = el;
          }
      }
#line 4759 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 205: /* enumerator_list: enumerator_list ',' enumerator  */
#line 1381 "src/parse.yy"
      {
          std::vector<Symbol *> *symList = (yyvsp[-2].symbolList);
          if (symList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              symList = new std::vector<Symbol *>;
          }
          if ((yyvsp[0].symbol) != NULL)
              symList->push_back((yyvsp[0].symbol));
          (yyval.symbolList) = symList;
      }
#line 4774 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 206: /* enumerator: enum_identifier  */
#line 1395 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol((yyvsp[0].constCharPtr), (yylsp[0]));
      }
#line 4782 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 207: /* enumerator: enum_identifier '=' constant_expression  */
#line 1399 "src/parse.yy"
      {
          int value;
          if ((yyvsp[-2].constCharPtr) != NULL && (yyvsp[0].expr) != NULL &&
              lGetConstantInt((yyvsp[0].expr), &value, (yylsp[0]), "Enumerator value")) {
              Symbol *sym = new Symbol((yyvsp[-2].constCharPtr), (yylsp[-2]));
              sym->constValue = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                                              (uint32_t)value, (yylsp[0]));
              (yyval.symbol) = sym;
          }
          else
              (yyval.symbol) = NULL;
      }
#line 4799 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 208: /* type_qualifier: TOKEN_CONST  */
#line 1414 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_CONST; }
#line 4805 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 209: /* type_qualifier: TOKEN_UNIFORM  */
#line 1415 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNIFORM; }
#line 4811 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 210: /* type_qualifier: TOKEN_VARYING  */
#line 1416 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_VARYING; }
#line 4817 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 211: /* type_qualifier: TOKEN_TASK  */
#line 1417 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_TASK; }
#line 4823 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 212: /* type_qualifier: TOKEN_UNMASKED  */
#line 1418 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNMASKED; }
#line 4829 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 213: /* type_qualifier: TOKEN_EXPORT  */
#line 1419 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_EXPORT; }
#line 4835 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 214: /* type_qualifier: TOKEN_INLINE  */
#line 1420 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_INLINE; }
#line 4841 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 215: /* type_qualifier: TOKEN_NOINLINE  */
#line 1421 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_NOINLINE; }
#line 4847 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 216: /* type_qualifier: TOKEN_VECTORCALL  */
#line 1422 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_VECTORCALL; }
#line 4853 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 217: /* type_qualifier: TOKEN_REGCALL  */
#line 1423 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_REGCALL; }
#line 4859 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 218: /* type_qualifier: TOKEN_SIGNED  */
#line 1424 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_SIGNED; }
#line 4865 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 219: /* type_qualifier: TOKEN_UNSIGNED  */
#line 1425 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNSIGNED; }
#line 4871 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 220: /* type_qualifier_list: type_qualifier  */
#line 1430 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[0].typeQualifier);
    }
#line 4879 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 221: /* type_qualifier_list: type_qualifier_list type_qualifier  */
#line 1434 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[-1].typeQualifier) | (yyvsp[0].typeQualifier);
    }
#line 4887 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 222: /* declarator: pointer direct_declarator  */
#line 1441 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != NULL) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != NULL)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4903 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 223: /* declarator: reference direct_declarator  */
#line 1453 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != NULL) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != NULL)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4919 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 225: /* int_constant: TOKEN_INT8_CONSTANT  */
#line 1468 "src/parse.yy"
                          { (yyval.intVal) = yylval.intVal; }
#line 4925 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 226: /* int_constant: TOKEN_INT16_CONSTANT  */
#line 1469 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4931 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 227: /* int_constant: TOKEN_INT32_CONSTANT  */
#line 1470 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4937 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 228: /* int_constant: TOKEN_INT64_CONSTANT  */
#line 1471 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4943 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 229: /* direct_declarator: TOKEN_IDENTIFIER  */
#line 1476 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
      }
#line 4953 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 230: /* direct_declarator: TOKEN_TEMPLATE_NAME  */
#line 1484 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
      }
#line 4963 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 231: /* direct_declarator: '(' declarator ')'  */
#line 1490 "src/parse.yy"
    {
        (yyval.declarator) = (yyvsp[-1].declarator);
    }
#line 4971 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 232: /* direct_declarator: direct_declarator '[' constant_expression ']'  */
#line 1494 "src/parse.yy"
    {
        int size;
        if ((yyvsp[-3].declarator) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            if (size < 0) {
                Error((yylsp[-1]), "Array dimension must be non-negative.");
                (yyval.declarator) = NULL;
            }
            else {
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                d->arraySize = size;
                d->child = (yyvsp[-3].declarator);
                (yyval.declarator) = d;
            }
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4993 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 233: /* direct_declarator: direct_declarator '[' ']'  */
#line 1512 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != NULL) {
            Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
            d->arraySize = 0; // unsize
            d->child = (yyvsp[-2].declarator);
            (yyval.declarator) = d;
        }
        else
            (yyval.declarator) = NULL;
    }
#line 5008 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 234: /* direct_declarator: direct_declarator '[' error ']'  */
#line 1523 "src/parse.yy"
    {
         (yyval.declarator) = NULL;
    }
#line 5016 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 235: /* direct_declarator: direct_declarator '(' parameter_type_list ')'  */
#line 1527 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) != NULL) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != NULL)
                  d->functionParams = *(yyvsp[-1].declarationList);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = NULL;
      }
#line 5032 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 236: /* direct_declarator: direct_declarator '(' ')'  */
#line 1539 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != NULL) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = NULL;
      }
#line 5046 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 237: /* direct_declarator: direct_declarator '(' error ')'  */
#line 1549 "src/parse.yy"
    {
        (yyval.declarator) = NULL;
    }
#line 5054 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 238: /* pointer: '*'  */
#line 1557 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_POINTER, (yylsp[0]));
    }
#line 5062 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 239: /* pointer: '*' type_qualifier_list  */
#line 1561 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[0].typeQualifier);
          (yyval.declarator) = d;
      }
#line 5072 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 240: /* pointer: '*' pointer  */
#line 1567 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 5082 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 241: /* pointer: '*' type_qualifier_list pointer  */
#line 1573 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-2]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[-1].typeQualifier);
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 5093 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 242: /* reference: '&'  */
#line 1584 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
    }
#line 5101 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 243: /* parameter_type_list: parameter_list  */
#line 1591 "src/parse.yy"
                     { (yyval.declarationList) = (yyvsp[0].declarationList); }
#line 5107 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 244: /* parameter_list: parameter_declaration  */
#line 1596 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != NULL)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 5118 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 245: /* parameter_list: parameter_list ',' parameter_declaration  */
#line 1603 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = (std::vector<Declaration *> *)(yyvsp[-2].declarationList);
        if (dl == NULL)
            dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != NULL)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 5131 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 246: /* parameter_list: error ','  */
#line 1612 "src/parse.yy"
    {
        lSuggestParamListAlternates();
        (yyval.declarationList) = NULL;
    }
#line 5140 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 247: /* parameter_declaration: declaration_specifiers declarator  */
#line 1620 "src/parse.yy"
    {
        (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
    }
#line 5148 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 248: /* parameter_declaration: declaration_specifiers declarator '=' initializer  */
#line 1624 "src/parse.yy"
    {
        if ((yyvsp[-3].declSpecs) != NULL && (yyvsp[-2].declarator) != NULL) {
            (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
            (yyval.declaration) = new Declaration((yyvsp[-3].declSpecs), (yyvsp[-2].declarator));
        }
        else
            (yyval.declaration) = NULL;
    }
#line 5161 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 249: /* parameter_declaration: declaration_specifiers abstract_declarator  */
#line 1633 "src/parse.yy"
    {
        if ((yyvsp[-1].declSpecs) != NULL && (yyvsp[0].declarator) != NULL)
            (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        else
            (yyval.declaration) = NULL;
    }
#line 5172 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 250: /* parameter_declaration: declaration_specifiers  */
#line 1640 "src/parse.yy"
    {
        if ((yyvsp[0].declSpecs) == NULL)
            (yyval.declaration) = NULL;
        else
            (yyval.declaration) = new Declaration((yyvsp[0].declSpecs));
    }
#line 5183 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 252: /* type_name: specifier_qualifier_list abstract_declarator  */
#line 1658 "src/parse.yy"
    {
        if ((yyvsp[-1].type) == NULL || (yyvsp[0].declarator) == NULL)
            (yyval.type) = NULL;
        else {
            (yyvsp[0].declarator)->InitFromType((yyvsp[-1].type), NULL);
            (yyval.type) = (yyvsp[0].declarator)->type;
        }
    }
#line 5196 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 253: /* abstract_declarator: pointer  */
#line 1670 "src/parse.yy"
      {
          (yyval.declarator) = (yyvsp[0].declarator);
      }
#line 5204 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 255: /* abstract_declarator: pointer direct_abstract_declarator  */
#line 1675 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5218 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 256: /* abstract_declarator: reference  */
#line 1685 "src/parse.yy"
      {
          (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
      }
#line 5226 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 257: /* abstract_declarator: reference direct_abstract_declarator  */
#line 1689 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_REFERENCE, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5240 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 258: /* direct_abstract_declarator: '(' abstract_declarator ')'  */
#line 1702 "src/parse.yy"
      { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5246 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 259: /* direct_abstract_declarator: '[' ']'  */
#line 1704 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-1]), (yylsp[0])));
          d->arraySize = 0;
          (yyval.declarator) = d;
      }
#line 5256 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 260: /* direct_abstract_declarator: '[' constant_expression ']'  */
#line 1710 "src/parse.yy"
      {
        int size;
        if ((yyvsp[-1].expr) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            if (size < 0) {
                Error((yylsp[-1]), "Array dimension must be non-negative.");
                (yyval.declarator) = NULL;
            }
            else {
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
                d->arraySize = size;
                (yyval.declarator) = d;
            }
        }
        else
            (yyval.declarator) = NULL;
      }
#line 5277 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 261: /* direct_abstract_declarator: direct_abstract_declarator '[' ']'  */
#line 1727 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
              d->arraySize = 0;
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5292 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 262: /* direct_abstract_declarator: direct_abstract_declarator '[' constant_expression ']'  */
#line 1738 "src/parse.yy"
      {
          int size;
          if ((yyvsp[-3].declarator) != NULL && (yyvsp[-1].expr) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
              if (size < 0) {
                  Error((yylsp[-1]), "Array dimension must be non-negative.");
                  (yyval.declarator) = NULL;
              }
              else {
                  Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                  d->arraySize = size;
                  d->child = (yyvsp[-3].declarator);
                  (yyval.declarator) = d;
              }
          }
          else
              (yyval.declarator) = NULL;
      }
#line 5314 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 263: /* direct_abstract_declarator: '(' ')'  */
#line 1756 "src/parse.yy"
      { (yyval.declarator) = new Declarator(DK_FUNCTION, Union((yylsp[-1]), (yylsp[0]))); }
#line 5320 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 264: /* direct_abstract_declarator: '(' parameter_type_list ')'  */
#line 1758 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
          if ((yyvsp[-1].declarationList) != NULL) d->functionParams = *(yyvsp[-1].declarationList);
          (yyval.declarator) = d;
      }
#line 5330 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 265: /* direct_abstract_declarator: direct_abstract_declarator '(' ')'  */
#line 1764 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5344 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 266: /* direct_abstract_declarator: direct_abstract_declarator '(' parameter_type_list ')'  */
#line 1774 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != NULL) d->functionParams = *(yyvsp[-1].declarationList);
              (yyval.declarator) = d;
          }
      }
#line 5359 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 268: /* initializer: '{' initializer_list '}'  */
#line 1788 "src/parse.yy"
                               { (yyval.expr) = (yyvsp[-1].exprList); }
#line 5365 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 269: /* initializer: '{' initializer_list ',' '}'  */
#line 1789 "src/parse.yy"
                                   { (yyval.expr) = (yyvsp[-2].exprList); }
#line 5371 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 270: /* initializer_list: initializer  */
#line 1794 "src/parse.yy"
      { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 5377 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 271: /* initializer_list: initializer_list ',' initializer  */
#line 1796 "src/parse.yy"
      {
          ExprList *exprList = (yyvsp[-2].exprList);
          if (exprList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              exprList = new ExprList((yylsp[0]));
          }
          exprList->exprs.push_back((yyvsp[0].expr));
          exprList->pos = Union(exprList->pos, (yylsp[0]));
          (yyval.exprList) = exprList;
      }
#line 5392 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 272: /* pragma: TOKEN_PRAGMA  */
#line 1810 "src/parse.yy"
    {
        (yyval.pragmaAttributes) = (yylval.pragmaAttributes);
    }
#line 5400 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 273: /* attributed_statement: pragma attributed_statement  */
#line 1817 "src/parse.yy"
    {
        if (((yyvsp[-1].pragmaAttributes)->aType == PragmaAttributes::AttributeType::pragmaloop) && ((yyvsp[0].stmt) != NULL)) {
            std::pair<Globals::pragmaUnrollType, int> unrollVal = std::pair<Globals::pragmaUnrollType, int>((yyvsp[-1].pragmaAttributes)->unrollType, (yyvsp[-1].pragmaAttributes)->count);
            (yyvsp[0].stmt)->SetLoopAttribute(unrollVal);
        }
        (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 5412 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 287: /* statement: error ';'  */
#line 1841 "src/parse.yy"
    {
        lSuggestBuiltinAlternates();
        (yyval.stmt) = NULL;
    }
#line 5421 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 288: /* labeled_statement: goto_identifier ':' attributed_statement  */
#line 1849 "src/parse.yy"
    {
        (yyval.stmt) = new LabeledStmt((yyvsp[-2].constCharPtr), (yyvsp[0].stmt), (yylsp[-2]));
    }
#line 5429 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 289: /* labeled_statement: TOKEN_CASE constant_expression ':' attributed_statement  */
#line 1853 "src/parse.yy"
      {
          int value;
          if ((yyvsp[-2].expr) != NULL &&
              lGetConstantInt((yyvsp[-2].expr), &value, (yylsp[-2]), "Case statement value")) {
              (yyval.stmt) = new CaseStmt(value, (yyvsp[0].stmt), Union((yylsp[-3]), (yylsp[-2])));
          }
          else
              (yyval.stmt) = NULL;
      }
#line 5443 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 290: /* labeled_statement: TOKEN_DEFAULT ':' attributed_statement  */
#line 1863 "src/parse.yy"
      { (yyval.stmt) = new DefaultStmt((yyvsp[0].stmt), (yylsp[-2])); }
#line 5449 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 291: /* start_scope: '{'  */
#line 1867 "src/parse.yy"
          { m->symbolTable->PushScope(); }
#line 5455 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 292: /* end_scope: '}'  */
#line 1871 "src/parse.yy"
          { m->symbolTable->PopScope(); }
#line 5461 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 293: /* compound_statement: '{' '}'  */
#line 1875 "src/parse.yy"
              { (yyval.stmt) = NULL; }
#line 5467 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 294: /* compound_statement: start_scope statement_list end_scope  */
#line 1876 "src/parse.yy"
                                           { (yyval.stmt) = (yyvsp[-1].stmt); }
#line 5473 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 295: /* statement_list: attributed_statement  */
#line 1881 "src/parse.yy"
      {
          StmtList *sl = new StmtList((yylsp[0]));
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 5483 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 296: /* statement_list: statement_list attributed_statement  */
#line 1887 "src/parse.yy"
      {
          StmtList *sl = (StmtList *)(yyvsp[-1].stmt);
          if (sl == NULL) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sl = new StmtList((yylsp[0]));
          }
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 5497 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 297: /* expression_statement: ';'  */
#line 1899 "src/parse.yy"
          { (yyval.stmt) = NULL; }
#line 5503 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 298: /* expression_statement: expression ';'  */
#line 1900 "src/parse.yy"
                     { (yyval.stmt) = (yyvsp[-1].expr) ? new ExprStmt((yyvsp[-1].expr), (yylsp[-1])) : NULL; }
#line 5509 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 299: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement  */
#line 1905 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), NULL, false, (yylsp[-4])); }
#line 5515 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 300: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 1907 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), false, (yylsp[-6])); }
#line 5521 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 301: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement  */
#line 1909 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), NULL, true, (yylsp[-4])); }
#line 5527 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 302: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 1911 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), true, (yylsp[-6])); }
#line 5533 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 303: /* selection_statement: TOKEN_SWITCH '(' expression ')' attributed_statement  */
#line 1913 "src/parse.yy"
      { (yyval.stmt) = new SwitchStmt((yyvsp[-2].expr), (yyvsp[0].stmt), (yylsp[-4])); }
#line 5539 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 304: /* for_test: ';'  */
#line 1918 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 5545 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 305: /* for_test: expression ';'  */
#line 1920 "src/parse.yy"
      { (yyval.expr) = (yyvsp[-1].expr); }
#line 5551 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 308: /* for_scope: TOKEN_FOR  */
#line 1929 "src/parse.yy"
                { m->symbolTable->PushScope(); }
#line 5557 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 309: /* cfor_scope: TOKEN_CFOR  */
#line 1933 "src/parse.yy"
                 { m->symbolTable->PushScope(); }
#line 5563 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 310: /* foreach_scope: TOKEN_FOREACH  */
#line 1937 "src/parse.yy"
                    { m->symbolTable->PushScope(); }
#line 5569 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 311: /* foreach_tiled_scope: TOKEN_FOREACH_TILED  */
#line 1941 "src/parse.yy"
                          { m->symbolTable->PushScope(); }
#line 5575 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 312: /* foreach_identifier: TOKEN_IDENTIFIER  */
#line 1946 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), AtomicType::VaryingInt32->GetAsConstType());
    }
#line 5583 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 313: /* foreach_active_scope: TOKEN_FOREACH_ACTIVE  */
#line 1952 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 5589 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 314: /* foreach_active_identifier: TOKEN_IDENTIFIER  */
#line 1957 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), AtomicType::UniformInt64->GetAsConstType());
    }
#line 5597 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 315: /* integer_dotdotdot: TOKEN_INT32DOTDOTDOT_CONSTANT  */
#line 1963 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 5606 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 316: /* integer_dotdotdot: TOKEN_UINT32DOTDOTDOT_CONSTANT  */
#line 1967 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 5615 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 317: /* integer_dotdotdot: TOKEN_INT64DOTDOTDOT_CONSTANT  */
#line 1971 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 5624 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 318: /* integer_dotdotdot: TOKEN_UINT64DOTDOTDOT_CONSTANT  */
#line 1975 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 5633 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 319: /* foreach_dimension_specifier: foreach_identifier '=' assignment_expression TOKEN_DOTDOTDOT assignment_expression  */
#line 1983 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-4].symbol), (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 5641 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 320: /* foreach_dimension_specifier: foreach_identifier '=' integer_dotdotdot assignment_expression  */
#line 1987 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-3].symbol), (yyvsp[-1].expr), (yyvsp[0].expr));
    }
#line 5649 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 321: /* foreach_dimension_list: foreach_dimension_specifier  */
#line 1994 "src/parse.yy"
    {
        (yyval.foreachDimensionList) = new std::vector<ForeachDimension *>;
        (yyval.foreachDimensionList)->push_back((yyvsp[0].foreachDimension));
    }
#line 5658 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 322: /* foreach_dimension_list: foreach_dimension_list ',' foreach_dimension_specifier  */
#line 1999 "src/parse.yy"
    {
        std::vector<ForeachDimension *> *dv = (yyvsp[-2].foreachDimensionList);
        if (dv == NULL) {
            AssertPos((yylsp[-2]), m->errorCount > 0);
            dv = new std::vector<ForeachDimension *>;
        }
        if ((yyvsp[0].foreachDimension) != NULL)
            dv->push_back((yyvsp[0].foreachDimension));
        (yyval.foreachDimensionList) = dv;
    }
#line 5673 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 323: /* foreach_unique_scope: TOKEN_FOREACH_UNIQUE  */
#line 2012 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 5679 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 324: /* foreach_unique_identifier: TOKEN_IDENTIFIER  */
#line 2016 "src/parse.yy"
                       { (yyval.constCharPtr) = yylval.stringVal->c_str(); }
#line 5685 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 325: /* iteration_statement: TOKEN_WHILE '(' expression ')' attributed_statement  */
#line 2021 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(NULL, (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), false, (yylsp[-4])); }
#line 5691 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 326: /* iteration_statement: TOKEN_CWHILE '(' expression ')' attributed_statement  */
#line 2023 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(NULL, (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), true, (yylsp[-4])); }
#line 5697 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 327: /* iteration_statement: TOKEN_DO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 2025 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), false, (yylsp[-6])); }
#line 5703 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 328: /* iteration_statement: TOKEN_CDO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 2027 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), true, (yylsp[-6])); }
#line 5709 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 329: /* iteration_statement: for_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 2029 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), false, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 5717 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 330: /* iteration_statement: for_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 2033 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), false, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 5725 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 331: /* iteration_statement: cfor_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 2037 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), true, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 5733 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 332: /* iteration_statement: cfor_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 2041 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), true, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 5741 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 333: /* $@1: %empty  */
#line 2045 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }
         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 5755 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 334: /* iteration_statement: foreach_scope '(' foreach_dimension_list ')' $@1 attributed_statement  */
#line 2055 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-3]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), false, (yylsp[-5]));
         m->symbolTable->PopScope();
     }
#line 5777 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 335: /* $@2: %empty  */
#line 2073 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 5792 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 336: /* iteration_statement: foreach_tiled_scope '(' foreach_dimension_list ')' $@2 attributed_statement  */
#line 2084 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-5]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), true, (yylsp[-5]));
         m->symbolTable->PopScope();
     }
#line 5814 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 337: /* $@3: %empty  */
#line 2102 "src/parse.yy"
     {
         if ((yyvsp[-1].symbol) != NULL)
             m->symbolTable->AddVariable((yyvsp[-1].symbol));
     }
#line 5823 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 338: /* iteration_statement: foreach_active_scope '(' foreach_active_identifier ')' $@3 attributed_statement  */
#line 2107 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachActiveStmt((yyvsp[-3].symbol), (yyvsp[0].stmt), Union((yylsp[-5]), (yylsp[-2])));
         m->symbolTable->PopScope();
     }
#line 5832 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 339: /* $@4: %empty  */
#line 2113 "src/parse.yy"
     {
         Expr *expr = (yyvsp[-1].expr);
         const Type *type;
         if (expr != NULL &&
             (expr = TypeCheck(expr)) != NULL &&
             (type = expr->GetType()) != NULL) {
             const Type *iterType = type->GetAsUniformType()->GetAsConstType();
             Symbol *sym = new Symbol((yyvsp[-3].constCharPtr), (yylsp[-3]), iterType);
             m->symbolTable->AddVariable(sym);
         }
     }
#line 5848 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 340: /* iteration_statement: foreach_unique_scope '(' foreach_unique_identifier TOKEN_IN expression ')' $@4 attributed_statement  */
#line 2125 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachUniqueStmt((yyvsp[-5].constCharPtr), (yyvsp[-3].expr), (yyvsp[0].stmt), (yylsp[-7]));
         m->symbolTable->PopScope();
     }
#line 5857 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 341: /* goto_identifier: TOKEN_IDENTIFIER  */
#line 2132 "src/parse.yy"
                       { (yyval.constCharPtr) = yylval.stringVal->c_str(); }
#line 5863 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 342: /* jump_statement: TOKEN_GOTO goto_identifier ';'  */
#line 2137 "src/parse.yy"
      { (yyval.stmt) = new GotoStmt((yyvsp[-1].constCharPtr), (yylsp[-2]), (yylsp[-1])); }
#line 5869 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 343: /* jump_statement: TOKEN_CONTINUE ';'  */
#line 2139 "src/parse.yy"
      { (yyval.stmt) = new ContinueStmt((yylsp[-1])); }
#line 5875 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 344: /* jump_statement: TOKEN_BREAK ';'  */
#line 2141 "src/parse.yy"
      { (yyval.stmt) = new BreakStmt((yylsp[-1])); }
#line 5881 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 345: /* jump_statement: TOKEN_RETURN ';'  */
#line 2143 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt(NULL, (yylsp[-1])); }
#line 5887 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 346: /* jump_statement: TOKEN_RETURN expression ';'  */
#line 2145 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt((yyvsp[-1].expr), (yylsp[-2])); }
#line 5893 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 347: /* sync_statement: TOKEN_SYNC ';'  */
#line 2150 "src/parse.yy"
      { (yyval.stmt) = new ExprStmt(new SyncExpr((yylsp[-1])), (yylsp[-1])); }
#line 5899 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 348: /* delete_statement: TOKEN_DELETE expression ';'  */
#line 2155 "src/parse.yy"
    {
        (yyval.stmt) = new DeleteStmt((yyvsp[-1].expr), Union((yylsp[-2]), (yylsp[-1])));
    }
#line 5907 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 349: /* unmasked_statement: TOKEN_UNMASKED '{' statement_list '}'  */
#line 2162 "src/parse.yy"
    {
        (yyval.stmt) = new UnmaskedStmt((yyvsp[-1].stmt), (yylsp[-3]));
    }
#line 5915 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 350: /* print_statement: TOKEN_PRINT '(' string_constant ')' ';'  */
#line 2169 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-2].stringVal), NULL, (yylsp[-4]));
      }
#line 5923 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 351: /* print_statement: TOKEN_PRINT '(' string_constant ',' argument_expression_list ')' ';'  */
#line 2173 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].exprList), (yylsp[-6]));
      }
#line 5931 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 352: /* assert_statement: TOKEN_ASSERT '(' string_constant ',' expression ')' ';'  */
#line 2180 "src/parse.yy"
      {
          (yyval.stmt) = new AssertStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].expr), (yylsp[-6]));
      }
#line 5939 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 362: /* external_declaration: TOKEN_EXPORT '{' type_specifier_list '}' ';'  */
#line 2199 "src/parse.yy"
    {
        if ((yyvsp[-2].typeList) != NULL)
            m->AddExportedTypes(*(yyvsp[-2].typeList));
    }
#line 5948 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 363: /* external_declaration: declaration  */
#line 2204 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) != NULL)
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i)
                lAddDeclaration((yyvsp[0].declaration)->declSpecs, (yyvsp[0].declaration)->declarators[i]);
    }
#line 5958 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 365: /* $@5: %empty  */
#line 2214 "src/parse.yy"
    {
        lAddDeclaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        m->symbolTable->PushScope();
        lAddFunctionParams((yyvsp[0].declarator));
        lAddMaskToSymbolTable((yylsp[0]));
        if ((yyvsp[-1].declSpecs)->typeQualifiers & TYPEQUAL_TASK)
            lAddThreadIndexCountToSymbolTable((yylsp[0]));
    }
#line 5971 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 366: /* function_definition: declaration_specifiers declarator $@5 compound_statement  */
#line 2223 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != NULL) {
            // FIXME: Next list is redundant, as it's done in lAddDeclaration()
            (yyvsp[-2].declarator)->InitFromDeclSpecs((yyvsp[-3].declSpecs));
            const FunctionType *funcType = CastType<FunctionType>((yyvsp[-2].declarator)->type);
            if (funcType == NULL)
                AssertPos((yylsp[-3]), m->errorCount > 0);
            else if ((yyvsp[-3].declSpecs)->storageClass == SC_TYPEDEF)
                Error((yylsp[-3]), "Illegal \"typedef\" provided with function definition.");
            else {
                Stmt *code = (yyvsp[0].stmt);
                if (code == NULL) code = new StmtList((yylsp[0]));
                m->AddFunctionDefinition((yyvsp[-2].declarator)->name, funcType, code);
            }
        }
        m->symbolTable->PopScope(); // push in lAddFunctionParams();
    }
#line 5993 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 367: /* template_type_parameter: TOKEN_TYPENAME TOKEN_IDENTIFIER  */
#line 2252 "src/parse.yy"
      {
          (yyval.templateParm) = new TemplateTypeParmType(*(yyvsp[0].stringVal), Variability::VarType::Unbound, false, Union((yylsp[-1]), (yylsp[0])));
      }
#line 6001 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 368: /* template_type_parameter: TOKEN_TYPENAME TOKEN_IDENTIFIER '=' type_specifier  */
#line 2256 "src/parse.yy"
      {
          (yyval.templateParm) = new TemplateTypeParmType(*(yyvsp[-2].stringVal), Variability::VarType::Unbound, false, Union((yylsp[-3]), (yylsp[-2])));
          // TODO: implement
          Error((yylsp[0]), "Default values for template type parameters are not yet supported.");
      }
#line 6011 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 369: /* template_int_parameter: TOKEN_INT TOKEN_IDENTIFIER  */
#line 2265 "src/parse.yy"
      {
          (yyval.templateParm) = nullptr;
          // TODO: implement
          Error(Union((yylsp[-1]), (yylsp[0])), "Non-type template paramters are not yet supported.");
      }
#line 6021 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 372: /* template_parameter_list: template_parameter  */
#line 2279 "src/parse.yy"
      {
          TemplateParms *list = new TemplateParms();
          if ((yyvsp[0].templateParm) != nullptr) {
              list->Add((yyvsp[0].templateParm));
          }
          (yyval.templateParmList) = list;
      }
#line 6033 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 373: /* template_parameter_list: template_parameter_list ',' template_parameter  */
#line 2287 "src/parse.yy"
      {
          TemplateParms *list = (TemplateParms *) (yyvsp[-2].templateParmList);
          if (list == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              list = new TemplateParms();
          }
          if ((yyvsp[0].templateParm) != NULL) {
              list->Add((yyvsp[0].templateParm));
          }
          (yyval.templateParmList) = list;
      }
#line 6049 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 374: /* template_head: TOKEN_TEMPLATE '<' template_parameter_list '>'  */
#line 2302 "src/parse.yy"
      {
          (yyval.templateParmList) = (yyvsp[-1].templateParmList);
      }
#line 6057 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 375: /* $@6: %empty  */
#line 2309 "src/parse.yy"
      {
          // Scope for template parameters definition
          m->symbolTable->PushScope();
          TemplateParms *list = (TemplateParms *) (yyvsp[0].templateParmList);
          for(size_t i = 0; i < list->GetCount(); i++) {
              std::string name = (*list)[i]->GetName();
              SourcePos pos = (*list)[i]->GetSourcePos();
              m->AddTypeDef(name, (*list)[i], pos);
          }
      }
#line 6072 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 376: /* template_declaration: template_head $@6 declaration_specifiers declarator  */
#line 2320 "src/parse.yy"
      {
          lAddTemplateDeclaration((yyvsp[-3].templateParmList), (yyvsp[-1].declSpecs), (yyvsp[0].declarator));
          lAddFunctionParams((yyvsp[0].declarator));
          lAddMaskToSymbolTable((yylsp[0]));
          if ((yyvsp[-1].declSpecs)->typeQualifiers & TYPEQUAL_TASK) {
              Error((yylsp[-1]), "'task' not supported for templates.");
          }
          if ((yyvsp[-1].declSpecs)->typeQualifiers & TYPEQUAL_EXPORT) {
              Error((yylsp[-1]), "'export' not supported for templates.");
          }
          const FunctionType *ft = CastType<FunctionType>((yyvsp[0].declarator)->type);
          // Creating a new TemplateSymbol just to pass it further seems to be a waste
          (yyval.functionTemplateSym) = new TemplateSymbol((yyvsp[-3].templateParmList), (yyvsp[0].declarator)->name, ft, (yylsp[0]), false /*not used*/, false /*not used*/);
      }
#line 6091 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 377: /* template_function_declaration_or_definition: template_declaration ';'  */
#line 2338 "src/parse.yy"
      {
          // End templates parameters definition scope
          m->symbolTable->PopScope();
      }
#line 6100 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 378: /* template_function_declaration_or_definition: template_declaration compound_statement  */
#line 2343 "src/parse.yy"
      {
          if ((yyvsp[-1].functionTemplateSym) != NULL) {
              Stmt *code = (yyvsp[0].stmt);
              if (code == NULL) code = new StmtList((yylsp[0]));
              m->AddFunctionTemplateDefinition((yyvsp[-1].functionTemplateSym)->templateParms, (yyvsp[-1].functionTemplateSym)->name, (yyvsp[-1].functionTemplateSym)->type, code);
          }

          // End templates parameters definition scope
          m->symbolTable->PopScope();
      }
#line 6115 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 379: /* template_argument_list: rate_qualified_type_specifier  */
#line 2357 "src/parse.yy"
      {
          std::vector<std::pair<const Type *, SourcePos>> *vec = new std::vector<std::pair<const Type *, SourcePos>>;
          vec->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
          (yyval.typeList) = vec;
      }
#line 6125 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 380: /* template_argument_list: template_argument_list ',' rate_qualified_type_specifier  */
#line 2363 "src/parse.yy"
      {
          std::vector<std::pair<const Type *, SourcePos>> *vec = (std::vector<std::pair<const Type *, SourcePos>> *) (yyvsp[-2].typeList);
          vec->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
          (yyval.typeList) = vec;
      }
#line 6135 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 381: /* template_identifier: TOKEN_TEMPLATE_NAME  */
#line 2371 "src/parse.yy"
                          { (yyval.constCharPtr) = strdup(yytext); }
#line 6141 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 382: /* simple_template_id: template_identifier '<' template_argument_list '>'  */
#line 2376 "src/parse.yy"
      {
          // Template ID declartor
          Declarator *d = new Declarator(DK_BASE, (yylsp[-3]));
          d->name = (yyvsp[-3].constCharPtr);
          // Arguments vector
          std::vector<std::pair<const Type *, SourcePos>> *vec = (std::vector<std::pair<const Type *, SourcePos>> *) (yyvsp[-1].typeList);
          // Bundle template ID declarator and type list.
          (yyval.simpleTemplateID) = new std::pair(d, vec);
      }
#line 6155 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 383: /* simple_template_id: template_identifier  */
#line 2386 "src/parse.yy"
      {
          // Template ID declartor
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = (yyvsp[0].constCharPtr);
          // Arguments vector
          std::vector<std::pair<const Type *, SourcePos>> *vec = new std::vector<std::pair<const Type *, SourcePos>>;
          // Bundle template ID declarator and empty type list.
          (yyval.simpleTemplateID) = new std::pair(d, vec);
      }
#line 6169 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 384: /* template_function_instantiation: TOKEN_TEMPLATE declaration_specifiers simple_template_id '(' parameter_type_list ')' ';'  */
#line 2401 "src/parse.yy"
      {
          SimpleTemplateIDType *simpleTemplID = (SimpleTemplateIDType *) (yyvsp[-4].simpleTemplateID);

          // Function declarator
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-6]), (yylsp[-1])));
          d->child = simpleTemplID->first;
          if ((yyvsp[-2].declarationList) != NULL) {
              d->functionParams = *(yyvsp[-2].declarationList);
          }

          d->InitFromDeclSpecs((yyvsp[-5].declSpecs));
          const FunctionType *ftype = CastType<FunctionType>(d->type);

          m->AddFunctionTemplateInstantiation((yyvsp[-4].simpleTemplateID)->first->name, *(yyvsp[-4].simpleTemplateID)->second, ftype, Union((yylsp[-6]), (yylsp[-1])));
      }
#line 6189 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 385: /* template_function_instantiation: TOKEN_TEMPLATE declaration_specifiers simple_template_id '(' ')' ';'  */
#line 2417 "src/parse.yy"
      {
          SimpleTemplateIDType *simpleTemplID = (SimpleTemplateIDType *) (yyvsp[-3].simpleTemplateID);

          // Function declarator
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-5]), (yylsp[-1])));
          d->child = simpleTemplID->first;

          d->InitFromDeclSpecs((yyvsp[-4].declSpecs));
          const FunctionType *ftype = CastType<FunctionType>(d->type);

          m->AddFunctionTemplateInstantiation((yyvsp[-3].simpleTemplateID)->first->name, *(yyvsp[-3].simpleTemplateID)->second, ftype, Union((yylsp[-5]), (yylsp[-1])));
      }
#line 6206 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 387: /* template_function_specialization: TOKEN_TEMPLATE '<' '>' declaration_specifiers declarator ';'  */
#line 2436 "src/parse.yy"
      {
        Error((yyloc), "Template function specialization not yet supported.");
      }
#line 6214 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;

  case 388: /* template_function_specialization: TOKEN_TEMPLATE '<' '>' declaration_specifiers declarator compound_statement  */
#line 2440 "src/parse.yy"
      {
        Error((yyloc), "Template function specialization not yet supported.");
      }
#line 6222 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"
    break;


#line 6226 "/builddir/build/BUILD/ispc-1.19.0/redhat-linux-build/./parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2445 "src/parse.yy"



void yyerror(const char *s) {
    if (strlen(yytext) == 0)
        Error(yylloc, "Premature end of file: %s.", s);
    else
        Error(yylloc, "%s.", s);
}


static int
lYYTNameErr (char *yyres, const char *yystr)
{
  extern std::map<std::string, std::string> tokenNameRemap;
  Assert(tokenNameRemap.size() > 0);
  if (tokenNameRemap.find(yystr) != tokenNameRemap.end()) {
      std::string n = tokenNameRemap[yystr];
      if (yyres == NULL)
          return n.size();
      else
          return yystpcpy(yyres, n.c_str()) - yyres;
  }

  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}

static void
lSuggestBuiltinAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lBuiltinTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
         Error(yylloc, "%s", alts.c_str());
}


static void
lSuggestParamListAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lParamListTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
        Error(yylloc, "%s", alts.c_str());
}


static void
lAddDeclaration(DeclSpecs *ds, Declarator *decl) {
    if (ds == NULL || decl == NULL)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    if (ds->storageClass == SC_TYPEDEF)
        m->AddTypeDef(decl->name, decl->type, decl->pos);
    else {
        if (decl->type == NULL) {
            Assert(m->errorCount > 0);
            return;
        }

        decl->type = decl->type->ResolveUnboundVariability(Variability::Varying);

        const FunctionType *ft = CastType<FunctionType>(decl->type);
        if (ft != NULL) {
            bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
            bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
            bool isVectorCall = (ds->typeQualifiers & TYPEQUAL_VECTORCALL);
            bool isRegCall = (ds->typeQualifiers & TYPEQUAL_REGCALL);
            m->AddFunctionDeclaration(decl->name, ft, ds->storageClass,
                                      isInline, isNoInline, isVectorCall, isRegCall, decl->pos);
        }
        else {
            bool isConst = (ds->typeQualifiers & TYPEQUAL_CONST) != 0;
            m->AddGlobalVariable(decl->name, decl->type, decl->initExpr,
                                 isConst, decl->storageClass, decl->pos);
        }
    }
}

static void
lAddTemplateDeclaration(TemplateParms *templateParmList, DeclSpecs *ds, Declarator *decl) {
    if (ds == NULL || decl == NULL)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    if (ds->storageClass == SC_TYPEDEF) {
        // FIXME: source position
        Error(decl->pos, "Illegal \"typedef\" provided with function template.");
        return;
    } else {
        if (decl->type == NULL) {
            Assert(m->errorCount > 0);
            return;
        }

        //decl->type = decl->type->ResolveUnboundVariability(Variability::Varying);

        const FunctionType *ft = CastType<FunctionType>(decl->type);
        if (ft != NULL) {
            bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
            bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
            bool isVectorCall = (ds->typeQualifiers & TYPEQUAL_VECTORCALL);
            m->AddFunctionTemplateDeclaration(templateParmList, decl->name, ft, ds->storageClass,
                                              isInline, isNoInline, isVectorCall, decl->pos);
        }
        else {
            Error(decl->pos, "Only function templates are supported.");
        }
    }
}


/** We're about to start parsing the body of a function; add all of the
    parameters to the symbol table so that they're available.
*/
static void
lAddFunctionParams(Declarator *decl) {
    // It's responsibility of the caller to create a new symbol table scope.
    // For regular functions, the scope starts before function parameters.
    // For template functions, the scope starts before template parameters.
    if (decl == NULL) {
        return;
    }

    // walk down to the declarator for the function itself
    while (decl->kind != DK_FUNCTION && decl->child != NULL)
        decl = decl->child;
    if (decl->kind != DK_FUNCTION) {
        AssertPos(decl->pos, m->errorCount > 0);
        return;
    }

    // now loop over its parameters and add them to the symbol table
    for (unsigned int i = 0; i < decl->functionParams.size(); ++i) {
        Declaration *pdecl = decl->functionParams[i];
        Assert(pdecl != NULL && pdecl->declarators.size() == 1);
        Declarator *declarator = pdecl->declarators[0];
        if (declarator == NULL)
            AssertPos(decl->pos, m->errorCount > 0);
        else {
            Symbol *sym = new Symbol(declarator->name, declarator->pos,
                                     declarator->type, declarator->storageClass);
#ifndef NDEBUG
            bool ok = m->symbolTable->AddVariable(sym);
            if (ok == false)
                AssertPos(decl->pos, m->errorCount > 0);
#else
            m->symbolTable->AddVariable(sym);
#endif
        }
    }

    // The corresponding pop scope happens in function_definition rules
    // above...
}


/** Add a symbol for the built-in mask variable to the symbol table */
static void lAddMaskToSymbolTable(SourcePos pos) {
    const Type *t = NULL;
    switch (g->target->getMaskBitCount()) {
    case 1:
        t = AtomicType::VaryingBool;
        break;
    case 8:
        t = AtomicType::VaryingUInt8;
        break;
    case 16:
        t = AtomicType::VaryingUInt16;
        break;
    case 32:
        t = AtomicType::VaryingUInt32;
        break;
    case 64:
        t = AtomicType::VaryingUInt64;
        break;
    default:
        FATAL("Unhandled mask bitsize in lAddMaskToSymbolTable");
    }

    t = t->GetAsConstType();
    Symbol *maskSymbol = new Symbol("__mask", pos, t);
    m->symbolTable->AddVariable(maskSymbol);
}


/** Add the thread index and thread count variables to the symbol table
    (this should only be done for 'task'-qualified functions. */
static void lAddThreadIndexCountToSymbolTable(SourcePos pos) {
    const Type *type = AtomicType::UniformUInt32->GetAsConstType();

    Symbol *threadIndexSym = new Symbol("threadIndex", pos, type);
    m->symbolTable->AddVariable(threadIndexSym);

    Symbol *threadCountSym = new Symbol("threadCount", pos, type);
    m->symbolTable->AddVariable(threadCountSym);

    Symbol *taskIndexSym = new Symbol("taskIndex", pos, type);
    m->symbolTable->AddVariable(taskIndexSym);
    
    Symbol *taskCountSym = new Symbol("taskCount", pos, type);
    m->symbolTable->AddVariable(taskCountSym);
    
    Symbol *taskIndexSym0 = new Symbol("taskIndex0", pos, type);
    m->symbolTable->AddVariable(taskIndexSym0);
    Symbol *taskIndexSym1 = new Symbol("taskIndex1", pos, type);
    m->symbolTable->AddVariable(taskIndexSym1);
    Symbol *taskIndexSym2 = new Symbol("taskIndex2", pos, type);
    m->symbolTable->AddVariable(taskIndexSym2);

    
    Symbol *taskCountSym0 = new Symbol("taskCount0", pos, type);
    m->symbolTable->AddVariable(taskCountSym0);
    Symbol *taskCountSym1 = new Symbol("taskCount1", pos, type);
    m->symbolTable->AddVariable(taskCountSym1);
    Symbol *taskCountSym2 = new Symbol("taskCount2", pos, type);
    m->symbolTable->AddVariable(taskCountSym2);
}


/** Small utility routine to construct a string for error messages that
    suggests alternate tokens for possibly-misspelled ones... */
static std::string lGetAlternates(std::vector<std::string> &alternates) {
    std::string alts;
    if (alternates.size()) {
        alts += " Did you mean ";
        for (unsigned int i = 0; i < alternates.size(); ++i) {
            alts += std::string("\"") + alternates[i] + std::string("\"");
            if (i < alternates.size() - 1) alts += ", or ";
        }
        alts += "?";
    }
    return alts;
}

static const char *
lGetStorageClassString(StorageClass sc) {
    switch (sc) {
    case SC_NONE:
        return "";
    case SC_EXTERN:
        return "extern";
    case SC_STATIC:
        return "static";
    case SC_TYPEDEF:
        return "typedef";
    case SC_EXTERN_C:
        return "extern \"C\"";
    case SC_EXTERN_SYCL:
        return "extern \"SYCL\"";
    default:
        Assert(!"logic error in lGetStorageClassString()");
        return "";
    }
}


/** Given an expression, see if it is equal to a compile-time constant
    integer value.  If so, return true and return the value in *value.
    If the expression isn't a compile-time constant or isn't an integer
    type, return false.
*/
static bool
lGetConstantInt(Expr *expr, int *value, SourcePos pos, const char *usage) {
    if (expr == NULL)
        return false;
    expr = TypeCheck(expr);
    if (expr == NULL)
        return false;
    expr = Optimize(expr);
    if (expr == NULL)
        return false;

    std::pair<llvm::Constant *, bool> cValPair = expr->GetConstant(expr->GetType());
    llvm::Constant *cval = cValPair.first;
    if (cval == NULL) {
        Error(pos, "%s must be a compile-time constant.", usage);
        return false;
    }
    else {
        llvm::ConstantInt *ci = llvm::dyn_cast<llvm::ConstantInt>(cval);
        if (ci == NULL) {
            Error(pos, "%s must be a compile-time integer constant.", usage);
            return false;
        }
        if ((int64_t)((int32_t)ci->getSExtValue()) != ci->getSExtValue()) {
            Error(pos, "%s must be representable with a 32-bit integer.", usage);
            return false;
        }
        const Type *type = expr->GetType();
        if (type->IsUnsignedType())
            *value = (int)ci->getZExtValue();
        else
            *value = (int)ci->getSExtValue();
        return true;
    }
}


static EnumType *
lCreateEnumType(const char *name, std::vector<Symbol *> *enums, SourcePos pos) {
    if (enums == NULL)
        return NULL;

    EnumType *enumType = name ? new EnumType(name, pos) : new EnumType(pos);
    if (name != NULL)
        m->symbolTable->AddType(name, enumType, pos);

    lFinalizeEnumeratorSymbols(*enums, enumType);
    for (unsigned int i = 0; i < enums->size(); ++i)
        m->symbolTable->AddVariable((*enums)[i]);
    enumType->SetEnumerators(*enums);
    return enumType;
}


/** Given an array of enumerator symbols, make sure each of them has a
    ConstExpr * in their Symbol::constValue member that stores their
    unsigned integer value.  Symbols that had values explicitly provided
    in the source file will already have ConstExpr * set; we just need
    to set the values for the others here.
*/
static void
lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                           const EnumType *enumType) {
    enumType = enumType->GetAsConstType();
    enumType = enumType->GetAsUniformType();

    /* nextVal tracks the value for the next enumerant.  It starts from
       zero and goes up with each successive enumerant.  If any of them
       has a value specified, then nextVal is ignored for that one and is
       set to one plus that one's value for the default value for the next
       one. */
    uint32_t nextVal = 0;

    for (unsigned int i = 0; i < enums.size(); ++i) {
        enums[i]->type = enumType;
        if (enums[i]->constValue != NULL) {
            /* Already has a value, so first update nextVal with it. */
            int count = enums[i]->constValue->GetValues(&nextVal);
            AssertPos(enums[i]->pos, count == 1);
            ++nextVal;

            /* When the source file as being parsed, the ConstExpr for any
               enumerant with a specified value was set to have unsigned
               int32 type, since we haven't created the parent EnumType
               by then.  Therefore, add a little type cast from uint32 to
               the actual enum type here and optimize it, which will have
               us end up with a ConstExpr with the desired EnumType... */
            Expr *castExpr = new TypeCastExpr(enumType, enums[i]->constValue,
                                              enums[i]->pos);
            castExpr = Optimize(castExpr);
            enums[i]->constValue = llvm::dyn_cast<ConstExpr>(castExpr);
            AssertPos(enums[i]->pos, enums[i]->constValue != NULL);
        }
        else {
            enums[i]->constValue = new ConstExpr(enumType, nextVal++,
                                                 enums[i]->pos);
        }
    }
}
